import { r as e, a as t, i as s, p as r, S as i, g as n, b as a, h as o, c as h, d as l, e as c, f as u, _ as d, j as f, k as p, l as g, m as _, s as y, n as m, v, A as b, o as w, q as k, t as T, u as S, w as E, x as P, y as j, z as $, B as O, C as A, D as C, E as R, F as I, G as L, H as x, I as U, J as D, K as N, L as F, M as B, N as M, O as q, P as z, Q as K, R as G, T as H, U as J, V, W, X as Y, Y as Q, Z as X } from "./fetch-648a91f6.js";
import { c as Z } from "./alasql-f60045ee.js";
class ee extends Error {
  constructor(e3, t2 = "FunctionsError", s2) {
    super(e3), this.name = t2, this.context = s2;
  }
}
class te extends ee {
  constructor(e3) {
    super("Failed to send a request to the Edge Function", "FunctionsFetchError", e3);
  }
}
class se extends ee {
  constructor(e3) {
    super("Relay Error invoking the Edge Function", "FunctionsRelayError", e3);
  }
}
class re extends ee {
  constructor(e3) {
    super("Edge Function returned a non-2xx status code", "FunctionsHttpError", e3);
  }
}
var ie;
!function(e3) {
  e3.Any = "any", e3.ApNortheast1 = "ap-northeast-1", e3.ApNortheast2 = "ap-northeast-2", e3.ApSouth1 = "ap-south-1", e3.ApSoutheast1 = "ap-southeast-1", e3.ApSoutheast2 = "ap-southeast-2", e3.CaCentral1 = "ca-central-1", e3.EuCentral1 = "eu-central-1", e3.EuWest1 = "eu-west-1", e3.EuWest2 = "eu-west-2", e3.EuWest3 = "eu-west-3", e3.SaEast1 = "sa-east-1", e3.UsEast1 = "us-east-1", e3.UsWest1 = "us-west-1", e3.UsWest2 = "us-west-2";
}(ie || (ie = {}));
var ne = globalThis && globalThis.__awaiter || function(e3, t2, s2, r2) {
  return new (s2 || (s2 = Promise))(function(i2, n2) {
    function a2(e4) {
      try {
        h2(r2.next(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function o2(e4) {
      try {
        h2(r2.throw(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function h2(e4) {
      var t3;
      e4.done ? i2(e4.value) : (t3 = e4.value, t3 instanceof s2 ? t3 : new s2(function(e5) {
        e5(t3);
      })).then(a2, o2);
    }
    h2((r2 = r2.apply(e3, t2 || [])).next());
  });
};
class ae {
  constructor(e3, { headers: t2 = {}, customFetch: s2, region: r2 = ie.Any } = {}) {
    this.url = e3, this.headers = t2, this.region = r2, this.fetch = ((e4) => {
      let t3;
      return t3 = e4 || ("undefined" == typeof fetch ? (...e5) => import("./fetch-648a91f6.js").then((e6) => e6.$).then(({ default: t4 }) => t4(...e5)) : fetch), (...e5) => t3(...e5);
    })(s2);
  }
  setAuth(e3) {
    this.headers.Authorization = `Bearer ${e3}`;
  }
  invoke(e3, t2 = {}) {
    var s2;
    return ne(this, void 0, void 0, function* () {
      try {
        const { headers: r2, method: i2, body: n2 } = t2;
        let a2, o2 = {}, { region: h2 } = t2;
        h2 || (h2 = this.region), h2 && "any" !== h2 && (o2["x-region"] = h2), n2 && (r2 && !Object.prototype.hasOwnProperty.call(r2, "Content-Type") || !r2) && ("undefined" != typeof Blob && n2 instanceof Blob || n2 instanceof ArrayBuffer ? (o2["Content-Type"] = "application/octet-stream", a2 = n2) : "string" == typeof n2 ? (o2["Content-Type"] = "text/plain", a2 = n2) : "undefined" != typeof FormData && n2 instanceof FormData ? a2 = n2 : (o2["Content-Type"] = "application/json", a2 = JSON.stringify(n2)));
        const l2 = yield this.fetch(`${this.url}/${e3}`, { method: i2 || "POST", headers: Object.assign(Object.assign(Object.assign({}, o2), this.headers), r2), body: a2 }).catch((e4) => {
          throw new te(e4);
        }), c2 = l2.headers.get("x-relay-error");
        if (c2 && "true" === c2)
          throw new se(l2);
        if (!l2.ok)
          throw new re(l2);
        let u2, d2 = (null !== (s2 = l2.headers.get("Content-Type")) && void 0 !== s2 ? s2 : "text/plain").split(";")[0].trim();
        return u2 = "application/json" === d2 ? yield l2.json() : "application/octet-stream" === d2 ? yield l2.blob() : "text/event-stream" === d2 ? l2 : "multipart/form-data" === d2 ? yield l2.formData() : yield l2.text(), { data: u2, error: null };
      } catch (e4) {
        return { data: null, error: e4 };
      }
    });
  }
}
var oe = {}, he = {}, le = {}, ce = {}, ue = {}, de = {}, fe = {};
Object.defineProperty(fe, "__esModule", { value: true });
class pe extends Error {
  constructor(e3) {
    super(e3.message), this.name = "PostgrestError", this.details = e3.details, this.hint = e3.hint, this.code = e3.code;
  }
}
fe.default = pe;
var ge = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(de, "__esModule", { value: true });
const _e = ge(e), ye = ge(fe);
de.default = class {
  constructor(e3) {
    this.shouldThrowOnError = false, this.method = e3.method, this.url = e3.url, this.headers = e3.headers, this.schema = e3.schema, this.body = e3.body, this.shouldThrowOnError = e3.shouldThrowOnError, this.signal = e3.signal, this.isMaybeSingle = e3.isMaybeSingle, e3.fetch ? this.fetch = e3.fetch : "undefined" == typeof fetch ? this.fetch = _e.default : this.fetch = fetch;
  }
  throwOnError() {
    return this.shouldThrowOnError = true, this;
  }
  setHeader(e3, t2) {
    return this.headers = Object.assign({}, this.headers), this.headers[e3] = t2, this;
  }
  then(e3, t2) {
    void 0 === this.schema || (["GET", "HEAD"].includes(this.method) ? this.headers["Accept-Profile"] = this.schema : this.headers["Content-Profile"] = this.schema), "GET" !== this.method && "HEAD" !== this.method && (this.headers["Content-Type"] = "application/json");
    let s2 = (0, this.fetch)(this.url.toString(), { method: this.method, headers: this.headers, body: JSON.stringify(this.body), signal: this.signal }).then(async (e4) => {
      var t3, s3, r2;
      let i2 = null, n2 = null, a2 = null, o2 = e4.status, h2 = e4.statusText;
      if (e4.ok) {
        if ("HEAD" !== this.method) {
          const t4 = await e4.text();
          "" === t4 || (n2 = "text/csv" === this.headers.Accept || this.headers.Accept && this.headers.Accept.includes("application/vnd.pgrst.plan+text") ? t4 : JSON.parse(t4));
        }
        const r3 = null === (t3 = this.headers.Prefer) || void 0 === t3 ? void 0 : t3.match(/count=(exact|planned|estimated)/), l2 = null === (s3 = e4.headers.get("content-range")) || void 0 === s3 ? void 0 : s3.split("/");
        r3 && l2 && l2.length > 1 && (a2 = parseInt(l2[1])), this.isMaybeSingle && "GET" === this.method && Array.isArray(n2) && (n2.length > 1 ? (i2 = { code: "PGRST116", details: `Results contain ${n2.length} rows, application/vnd.pgrst.object+json requires 1 row`, hint: null, message: "JSON object requested, multiple (or no) rows returned" }, n2 = null, a2 = null, o2 = 406, h2 = "Not Acceptable") : n2 = 1 === n2.length ? n2[0] : null);
      } else {
        const t4 = await e4.text();
        try {
          i2 = JSON.parse(t4), Array.isArray(i2) && 404 === e4.status && (n2 = [], i2 = null, o2 = 200, h2 = "OK");
        } catch (s4) {
          404 === e4.status && "" === t4 ? (o2 = 204, h2 = "No Content") : i2 = { message: t4 };
        }
        if (i2 && this.isMaybeSingle && (null === (r2 = null == i2 ? void 0 : i2.details) || void 0 === r2 ? void 0 : r2.includes("0 rows")) && (i2 = null, o2 = 200, h2 = "OK"), i2 && this.shouldThrowOnError)
          throw new ye.default(i2);
      }
      return { error: i2, data: n2, count: a2, status: o2, statusText: h2 };
    });
    return this.shouldThrowOnError || (s2 = s2.catch((e4) => {
      var t3, s3, r2;
      return { error: { message: `${null !== (t3 = null == e4 ? void 0 : e4.name) && void 0 !== t3 ? t3 : "FetchError"}: ${null == e4 ? void 0 : e4.message}`, details: `${null !== (s3 = null == e4 ? void 0 : e4.stack) && void 0 !== s3 ? s3 : ""}`, hint: "", code: `${null !== (r2 = null == e4 ? void 0 : e4.code) && void 0 !== r2 ? r2 : ""}` }, data: null, count: null, status: 0, statusText: "" };
    })), s2.then(e3, t2);
  }
};
var me = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(ue, "__esModule", { value: true });
const ve = me(de);
let be = class extends ve.default {
  select(e3) {
    let t2 = false;
    const s2 = (null != e3 ? e3 : "*").split("").map((e4) => /\s/.test(e4) && !t2 ? "" : ('"' === e4 && (t2 = !t2), e4)).join("");
    return this.url.searchParams.set("select", s2), this.headers.Prefer && (this.headers.Prefer += ","), this.headers.Prefer += "return=representation", this;
  }
  order(e3, { ascending: t2 = true, nullsFirst: s2, foreignTable: r2, referencedTable: i2 = r2 } = {}) {
    const n2 = i2 ? `${i2}.order` : "order", a2 = this.url.searchParams.get(n2);
    return this.url.searchParams.set(n2, `${a2 ? `${a2},` : ""}${e3}.${t2 ? "asc" : "desc"}${void 0 === s2 ? "" : s2 ? ".nullsfirst" : ".nullslast"}`), this;
  }
  limit(e3, { foreignTable: t2, referencedTable: s2 = t2 } = {}) {
    const r2 = void 0 === s2 ? "limit" : `${s2}.limit`;
    return this.url.searchParams.set(r2, `${e3}`), this;
  }
  range(e3, t2, { foreignTable: s2, referencedTable: r2 = s2 } = {}) {
    const i2 = void 0 === r2 ? "offset" : `${r2}.offset`, n2 = void 0 === r2 ? "limit" : `${r2}.limit`;
    return this.url.searchParams.set(i2, `${e3}`), this.url.searchParams.set(n2, "" + (t2 - e3 + 1)), this;
  }
  abortSignal(e3) {
    return this.signal = e3, this;
  }
  single() {
    return this.headers.Accept = "application/vnd.pgrst.object+json", this;
  }
  maybeSingle() {
    return "GET" === this.method ? this.headers.Accept = "application/json" : this.headers.Accept = "application/vnd.pgrst.object+json", this.isMaybeSingle = true, this;
  }
  csv() {
    return this.headers.Accept = "text/csv", this;
  }
  geojson() {
    return this.headers.Accept = "application/geo+json", this;
  }
  explain({ analyze: e3 = false, verbose: t2 = false, settings: s2 = false, buffers: r2 = false, wal: i2 = false, format: n2 = "text" } = {}) {
    var a2;
    const o2 = [e3 ? "analyze" : null, t2 ? "verbose" : null, s2 ? "settings" : null, r2 ? "buffers" : null, i2 ? "wal" : null].filter(Boolean).join("|"), h2 = null !== (a2 = this.headers.Accept) && void 0 !== a2 ? a2 : "application/json";
    return this.headers.Accept = `application/vnd.pgrst.plan+${n2}; for="${h2}"; options=${o2};`, this;
  }
  rollback() {
    var e3;
    return (null !== (e3 = this.headers.Prefer) && void 0 !== e3 ? e3 : "").trim().length > 0 ? this.headers.Prefer += ",tx=rollback" : this.headers.Prefer = "tx=rollback", this;
  }
  returns() {
    return this;
  }
};
ue.default = be;
var we = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(ce, "__esModule", { value: true });
const ke = we(ue);
let Te = class extends ke.default {
  eq(e3, t2) {
    return this.url.searchParams.append(e3, `eq.${t2}`), this;
  }
  neq(e3, t2) {
    return this.url.searchParams.append(e3, `neq.${t2}`), this;
  }
  gt(e3, t2) {
    return this.url.searchParams.append(e3, `gt.${t2}`), this;
  }
  gte(e3, t2) {
    return this.url.searchParams.append(e3, `gte.${t2}`), this;
  }
  lt(e3, t2) {
    return this.url.searchParams.append(e3, `lt.${t2}`), this;
  }
  lte(e3, t2) {
    return this.url.searchParams.append(e3, `lte.${t2}`), this;
  }
  like(e3, t2) {
    return this.url.searchParams.append(e3, `like.${t2}`), this;
  }
  likeAllOf(e3, t2) {
    return this.url.searchParams.append(e3, `like(all).{${t2.join(",")}}`), this;
  }
  likeAnyOf(e3, t2) {
    return this.url.searchParams.append(e3, `like(any).{${t2.join(",")}}`), this;
  }
  ilike(e3, t2) {
    return this.url.searchParams.append(e3, `ilike.${t2}`), this;
  }
  ilikeAllOf(e3, t2) {
    return this.url.searchParams.append(e3, `ilike(all).{${t2.join(",")}}`), this;
  }
  ilikeAnyOf(e3, t2) {
    return this.url.searchParams.append(e3, `ilike(any).{${t2.join(",")}}`), this;
  }
  is(e3, t2) {
    return this.url.searchParams.append(e3, `is.${t2}`), this;
  }
  in(e3, t2) {
    const s2 = Array.from(new Set(t2)).map((e4) => "string" == typeof e4 && new RegExp("[,()]").test(e4) ? `"${e4}"` : `${e4}`).join(",");
    return this.url.searchParams.append(e3, `in.(${s2})`), this;
  }
  contains(e3, t2) {
    return "string" == typeof t2 ? this.url.searchParams.append(e3, `cs.${t2}`) : Array.isArray(t2) ? this.url.searchParams.append(e3, `cs.{${t2.join(",")}}`) : this.url.searchParams.append(e3, `cs.${JSON.stringify(t2)}`), this;
  }
  containedBy(e3, t2) {
    return "string" == typeof t2 ? this.url.searchParams.append(e3, `cd.${t2}`) : Array.isArray(t2) ? this.url.searchParams.append(e3, `cd.{${t2.join(",")}}`) : this.url.searchParams.append(e3, `cd.${JSON.stringify(t2)}`), this;
  }
  rangeGt(e3, t2) {
    return this.url.searchParams.append(e3, `sr.${t2}`), this;
  }
  rangeGte(e3, t2) {
    return this.url.searchParams.append(e3, `nxl.${t2}`), this;
  }
  rangeLt(e3, t2) {
    return this.url.searchParams.append(e3, `sl.${t2}`), this;
  }
  rangeLte(e3, t2) {
    return this.url.searchParams.append(e3, `nxr.${t2}`), this;
  }
  rangeAdjacent(e3, t2) {
    return this.url.searchParams.append(e3, `adj.${t2}`), this;
  }
  overlaps(e3, t2) {
    return "string" == typeof t2 ? this.url.searchParams.append(e3, `ov.${t2}`) : this.url.searchParams.append(e3, `ov.{${t2.join(",")}}`), this;
  }
  textSearch(e3, t2, { config: s2, type: r2 } = {}) {
    let i2 = "";
    "plain" === r2 ? i2 = "pl" : "phrase" === r2 ? i2 = "ph" : "websearch" === r2 && (i2 = "w");
    const n2 = void 0 === s2 ? "" : `(${s2})`;
    return this.url.searchParams.append(e3, `${i2}fts${n2}.${t2}`), this;
  }
  match(e3) {
    return Object.entries(e3).forEach(([e4, t2]) => {
      this.url.searchParams.append(e4, `eq.${t2}`);
    }), this;
  }
  not(e3, t2, s2) {
    return this.url.searchParams.append(e3, `not.${t2}.${s2}`), this;
  }
  or(e3, { foreignTable: t2, referencedTable: s2 = t2 } = {}) {
    const r2 = s2 ? `${s2}.or` : "or";
    return this.url.searchParams.append(r2, `(${e3})`), this;
  }
  filter(e3, t2, s2) {
    return this.url.searchParams.append(e3, `${t2}.${s2}`), this;
  }
};
ce.default = Te;
var Se = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(le, "__esModule", { value: true });
const Ee = Se(ce);
le.default = class {
  constructor(e3, { headers: t2 = {}, schema: s2, fetch: r2 }) {
    this.url = e3, this.headers = t2, this.schema = s2, this.fetch = r2;
  }
  select(e3, { head: t2 = false, count: s2 } = {}) {
    const r2 = t2 ? "HEAD" : "GET";
    let i2 = false;
    const n2 = (null != e3 ? e3 : "*").split("").map((e4) => /\s/.test(e4) && !i2 ? "" : ('"' === e4 && (i2 = !i2), e4)).join("");
    return this.url.searchParams.set("select", n2), s2 && (this.headers.Prefer = `count=${s2}`), new Ee.default({ method: r2, url: this.url, headers: this.headers, schema: this.schema, fetch: this.fetch, allowEmpty: false });
  }
  insert(e3, { count: t2, defaultToNull: s2 = true } = {}) {
    const r2 = [];
    if (this.headers.Prefer && r2.push(this.headers.Prefer), t2 && r2.push(`count=${t2}`), s2 || r2.push("missing=default"), this.headers.Prefer = r2.join(","), Array.isArray(e3)) {
      const t3 = e3.reduce((e4, t4) => e4.concat(Object.keys(t4)), []);
      if (t3.length > 0) {
        const e4 = [...new Set(t3)].map((e5) => `"${e5}"`);
        this.url.searchParams.set("columns", e4.join(","));
      }
    }
    return new Ee.default({ method: "POST", url: this.url, headers: this.headers, schema: this.schema, body: e3, fetch: this.fetch, allowEmpty: false });
  }
  upsert(e3, { onConflict: t2, ignoreDuplicates: s2 = false, count: r2, defaultToNull: i2 = true } = {}) {
    const n2 = [`resolution=${s2 ? "ignore" : "merge"}-duplicates`];
    if (void 0 !== t2 && this.url.searchParams.set("on_conflict", t2), this.headers.Prefer && n2.push(this.headers.Prefer), r2 && n2.push(`count=${r2}`), i2 || n2.push("missing=default"), this.headers.Prefer = n2.join(","), Array.isArray(e3)) {
      const t3 = e3.reduce((e4, t4) => e4.concat(Object.keys(t4)), []);
      if (t3.length > 0) {
        const e4 = [...new Set(t3)].map((e5) => `"${e5}"`);
        this.url.searchParams.set("columns", e4.join(","));
      }
    }
    return new Ee.default({ method: "POST", url: this.url, headers: this.headers, schema: this.schema, body: e3, fetch: this.fetch, allowEmpty: false });
  }
  update(e3, { count: t2 } = {}) {
    const s2 = [];
    return this.headers.Prefer && s2.push(this.headers.Prefer), t2 && s2.push(`count=${t2}`), this.headers.Prefer = s2.join(","), new Ee.default({ method: "PATCH", url: this.url, headers: this.headers, schema: this.schema, body: e3, fetch: this.fetch, allowEmpty: false });
  }
  delete({ count: e3 } = {}) {
    const t2 = [];
    return e3 && t2.push(`count=${e3}`), this.headers.Prefer && t2.unshift(this.headers.Prefer), this.headers.Prefer = t2.join(","), new Ee.default({ method: "DELETE", url: this.url, headers: this.headers, schema: this.schema, fetch: this.fetch, allowEmpty: false });
  }
};
var Pe = {}, je = {};
Object.defineProperty(je, "__esModule", { value: true }), je.version = void 0, je.version = "0.0.0-automated", Object.defineProperty(Pe, "__esModule", { value: true }), Pe.DEFAULT_HEADERS = void 0;
const $e = je;
Pe.DEFAULT_HEADERS = { "X-Client-Info": `postgrest-js/${$e.version}` };
var Oe = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(he, "__esModule", { value: true });
const Ae = Oe(le), Ce = Oe(ce), Re = Pe;
he.default = class e2 {
  constructor(e3, { headers: t2 = {}, schema: s2, fetch: r2 } = {}) {
    this.url = e3, this.headers = Object.assign(Object.assign({}, Re.DEFAULT_HEADERS), t2), this.schemaName = s2, this.fetch = r2;
  }
  from(e3) {
    const t2 = new URL(`${this.url}/${e3}`);
    return new Ae.default(t2, { headers: Object.assign({}, this.headers), schema: this.schemaName, fetch: this.fetch });
  }
  schema(t2) {
    return new e2(this.url, { headers: this.headers, schema: t2, fetch: this.fetch });
  }
  rpc(e3, t2 = {}, { head: s2 = false, get: r2 = false, count: i2 } = {}) {
    let n2;
    const a2 = new URL(`${this.url}/rpc/${e3}`);
    let o2;
    s2 || r2 ? (n2 = s2 ? "HEAD" : "GET", Object.entries(t2).filter(([e4, t3]) => void 0 !== t3).map(([e4, t3]) => [e4, Array.isArray(t3) ? `{${t3.join(",")}}` : `${t3}`]).forEach(([e4, t3]) => {
      a2.searchParams.append(e4, t3);
    })) : (n2 = "POST", o2 = t2);
    const h2 = Object.assign({}, this.headers);
    return i2 && (h2.Prefer = `count=${i2}`), new Ce.default({ method: n2, url: a2, headers: h2, schema: this.schemaName, body: o2, fetch: this.fetch, allowEmpty: false });
  }
};
var Ie = Z && Z.__importDefault || function(e3) {
  return e3 && e3.__esModule ? e3 : { default: e3 };
};
Object.defineProperty(oe, "__esModule", { value: true }), oe.PostgrestBuilder = oe.PostgrestTransformBuilder = oe.PostgrestFilterBuilder = oe.PostgrestQueryBuilder = oe.PostgrestClient = void 0;
const Le = Ie(he);
oe.PostgrestClient = Le.default;
const xe = Ie(le);
oe.PostgrestQueryBuilder = xe.default;
const Ue = Ie(ce);
oe.PostgrestFilterBuilder = Ue.default;
const De = Ie(ue);
oe.PostgrestTransformBuilder = De.default;
const Ne = Ie(de);
oe.PostgrestBuilder = Ne.default;
var Fe = oe.default = { PostgrestClient: Le.default, PostgrestQueryBuilder: xe.default, PostgrestFilterBuilder: Ue.default, PostgrestTransformBuilder: De.default, PostgrestBuilder: Ne.default };
const { PostgrestClient: Be, PostgrestQueryBuilder: Me, PostgrestFilterBuilder: qe, PostgrestTransformBuilder: ze, PostgrestBuilder: Ke } = Fe, Ge = { "X-Client-Info": "realtime-js/2.10.2" };
var He, Je, Ve, We, Ye, Qe;
!function(e3) {
  e3[e3.connecting = 0] = "connecting", e3[e3.open = 1] = "open", e3[e3.closing = 2] = "closing", e3[e3.closed = 3] = "closed";
}(He || (He = {})), function(e3) {
  e3.closed = "closed", e3.errored = "errored", e3.joined = "joined", e3.joining = "joining", e3.leaving = "leaving";
}(Je || (Je = {})), function(e3) {
  e3.close = "phx_close", e3.error = "phx_error", e3.join = "phx_join", e3.reply = "phx_reply", e3.leave = "phx_leave", e3.access_token = "access_token";
}(Ve || (Ve = {})), function(e3) {
  e3.websocket = "websocket";
}(We || (We = {})), function(e3) {
  e3.Connecting = "connecting", e3.Open = "open", e3.Closing = "closing", e3.Closed = "closed";
}(Ye || (Ye = {}));
class Xe {
  constructor() {
    this.HEADER_LENGTH = 1;
  }
  decode(e3, t2) {
    return e3.constructor === ArrayBuffer ? t2(this._binaryDecode(e3)) : t2("string" == typeof e3 ? JSON.parse(e3) : {});
  }
  _binaryDecode(e3) {
    const t2 = new DataView(e3), s2 = new TextDecoder();
    return this._decodeBroadcast(e3, t2, s2);
  }
  _decodeBroadcast(e3, t2, s2) {
    const r2 = t2.getUint8(1), i2 = t2.getUint8(2);
    let n2 = this.HEADER_LENGTH + 2;
    const a2 = s2.decode(e3.slice(n2, n2 + r2));
    n2 += r2;
    const o2 = s2.decode(e3.slice(n2, n2 + i2));
    n2 += i2;
    return { ref: null, topic: a2, event: o2, payload: JSON.parse(s2.decode(e3.slice(n2, e3.byteLength))) };
  }
}
class Ze {
  constructor(e3, t2) {
    this.callback = e3, this.timerCalc = t2, this.timer = void 0, this.tries = 0, this.callback = e3, this.timerCalc = t2;
  }
  reset() {
    this.tries = 0, clearTimeout(this.timer);
  }
  scheduleTimeout() {
    clearTimeout(this.timer), this.timer = setTimeout(() => {
      this.tries = this.tries + 1, this.callback();
    }, this.timerCalc(this.tries + 1));
  }
}
!function(e3) {
  e3.abstime = "abstime", e3.bool = "bool", e3.date = "date", e3.daterange = "daterange", e3.float4 = "float4", e3.float8 = "float8", e3.int2 = "int2", e3.int4 = "int4", e3.int4range = "int4range", e3.int8 = "int8", e3.int8range = "int8range", e3.json = "json", e3.jsonb = "jsonb", e3.money = "money", e3.numeric = "numeric", e3.oid = "oid", e3.reltime = "reltime", e3.text = "text", e3.time = "time", e3.timestamp = "timestamp", e3.timestamptz = "timestamptz", e3.timetz = "timetz", e3.tsrange = "tsrange", e3.tstzrange = "tstzrange";
}(Qe || (Qe = {}));
const et = (e3, t2, s2 = {}) => {
  var r2;
  const i2 = null !== (r2 = s2.skipTypes) && void 0 !== r2 ? r2 : [];
  return Object.keys(t2).reduce((s3, r3) => (s3[r3] = tt(r3, e3, t2, i2), s3), {});
}, tt = (e3, t2, s2, r2) => {
  const i2 = t2.find((t3) => t3.name === e3), n2 = null == i2 ? void 0 : i2.type, a2 = s2[e3];
  return n2 && !r2.includes(n2) ? st(n2, a2) : rt(a2);
}, st = (e3, t2) => {
  if ("_" === e3.charAt(0)) {
    const s2 = e3.slice(1, e3.length);
    return ot(t2, s2);
  }
  switch (e3) {
    case Qe.bool:
      return it(t2);
    case Qe.float4:
    case Qe.float8:
    case Qe.int2:
    case Qe.int4:
    case Qe.int8:
    case Qe.numeric:
    case Qe.oid:
      return nt(t2);
    case Qe.json:
    case Qe.jsonb:
      return at(t2);
    case Qe.timestamp:
      return ht(t2);
    case Qe.abstime:
    case Qe.date:
    case Qe.daterange:
    case Qe.int4range:
    case Qe.int8range:
    case Qe.money:
    case Qe.reltime:
    case Qe.text:
    case Qe.time:
    case Qe.timestamptz:
    case Qe.timetz:
    case Qe.tsrange:
    case Qe.tstzrange:
    default:
      return rt(t2);
  }
}, rt = (e3) => e3, it = (e3) => {
  switch (e3) {
    case "t":
      return true;
    case "f":
      return false;
    default:
      return e3;
  }
}, nt = (e3) => {
  if ("string" == typeof e3) {
    const t2 = parseFloat(e3);
    if (!Number.isNaN(t2))
      return t2;
  }
  return e3;
}, at = (e3) => {
  if ("string" == typeof e3)
    try {
      return JSON.parse(e3);
    } catch (t2) {
      return e3;
    }
  return e3;
}, ot = (e3, t2) => {
  if ("string" != typeof e3)
    return e3;
  const s2 = e3.length - 1, r2 = e3[s2];
  if ("{" === e3[0] && "}" === r2) {
    let r3;
    const i2 = e3.slice(1, s2);
    try {
      r3 = JSON.parse("[" + i2 + "]");
    } catch (e4) {
      r3 = i2 ? i2.split(",") : [];
    }
    return r3.map((e4) => st(t2, e4));
  }
  return e3;
}, ht = (e3) => "string" == typeof e3 ? e3.replace(" ", "T") : e3, lt = (e3) => {
  let t2 = e3;
  return t2 = t2.replace(/^ws/i, "http"), t2 = t2.replace(/(\/socket\/websocket|\/socket|\/websocket)\/?$/i, ""), t2.replace(/\/+$/, "");
};
class ct {
  constructor(e3, t2, s2 = {}, r2 = 1e4) {
    this.channel = e3, this.event = t2, this.payload = s2, this.timeout = r2, this.sent = false, this.timeoutTimer = void 0, this.ref = "", this.receivedResp = null, this.recHooks = [], this.refEvent = null;
  }
  resend(e3) {
    this.timeout = e3, this._cancelRefEvent(), this.ref = "", this.refEvent = null, this.receivedResp = null, this.sent = false, this.send();
  }
  send() {
    this._hasReceived("timeout") || (this.startTimeout(), this.sent = true, this.channel.socket.push({ topic: this.channel.topic, event: this.event, payload: this.payload, ref: this.ref, join_ref: this.channel._joinRef() }));
  }
  updatePayload(e3) {
    this.payload = Object.assign(Object.assign({}, this.payload), e3);
  }
  receive(e3, t2) {
    var s2;
    return this._hasReceived(e3) && t2(null === (s2 = this.receivedResp) || void 0 === s2 ? void 0 : s2.response), this.recHooks.push({ status: e3, callback: t2 }), this;
  }
  startTimeout() {
    if (this.timeoutTimer)
      return;
    this.ref = this.channel.socket._makeRef(), this.refEvent = this.channel._replyEventName(this.ref);
    this.channel._on(this.refEvent, {}, (e3) => {
      this._cancelRefEvent(), this._cancelTimeout(), this.receivedResp = e3, this._matchReceive(e3);
    }), this.timeoutTimer = setTimeout(() => {
      this.trigger("timeout", {});
    }, this.timeout);
  }
  trigger(e3, t2) {
    this.refEvent && this.channel._trigger(this.refEvent, { status: e3, response: t2 });
  }
  destroy() {
    this._cancelRefEvent(), this._cancelTimeout();
  }
  _cancelRefEvent() {
    this.refEvent && this.channel._off(this.refEvent, {});
  }
  _cancelTimeout() {
    clearTimeout(this.timeoutTimer), this.timeoutTimer = void 0;
  }
  _matchReceive({ status: e3, response: t2 }) {
    this.recHooks.filter((t3) => t3.status === e3).forEach((e4) => e4.callback(t2));
  }
  _hasReceived(e3) {
    return this.receivedResp && this.receivedResp.status === e3;
  }
}
var ut, dt, ft, pt;
!function(e3) {
  e3.SYNC = "sync", e3.JOIN = "join", e3.LEAVE = "leave";
}(ut || (ut = {}));
class gt {
  constructor(e3, t2) {
    this.channel = e3, this.state = {}, this.pendingDiffs = [], this.joinRef = null, this.caller = { onJoin: () => {
    }, onLeave: () => {
    }, onSync: () => {
    } };
    const s2 = (null == t2 ? void 0 : t2.events) || { state: "presence_state", diff: "presence_diff" };
    this.channel._on(s2.state, {}, (e4) => {
      const { onJoin: t3, onLeave: s3, onSync: r2 } = this.caller;
      this.joinRef = this.channel._joinRef(), this.state = gt.syncState(this.state, e4, t3, s3), this.pendingDiffs.forEach((e5) => {
        this.state = gt.syncDiff(this.state, e5, t3, s3);
      }), this.pendingDiffs = [], r2();
    }), this.channel._on(s2.diff, {}, (e4) => {
      const { onJoin: t3, onLeave: s3, onSync: r2 } = this.caller;
      this.inPendingSyncState() ? this.pendingDiffs.push(e4) : (this.state = gt.syncDiff(this.state, e4, t3, s3), r2());
    }), this.onJoin((e4, t3, s3) => {
      this.channel._trigger("presence", { event: "join", key: e4, currentPresences: t3, newPresences: s3 });
    }), this.onLeave((e4, t3, s3) => {
      this.channel._trigger("presence", { event: "leave", key: e4, currentPresences: t3, leftPresences: s3 });
    }), this.onSync(() => {
      this.channel._trigger("presence", { event: "sync" });
    });
  }
  static syncState(e3, t2, s2, r2) {
    const i2 = this.cloneDeep(e3), n2 = this.transformState(t2), a2 = {}, o2 = {};
    return this.map(i2, (e4, t3) => {
      n2[e4] || (o2[e4] = t3);
    }), this.map(n2, (e4, t3) => {
      const s3 = i2[e4];
      if (s3) {
        const r3 = t3.map((e5) => e5.presence_ref), i3 = s3.map((e5) => e5.presence_ref), n3 = t3.filter((e5) => i3.indexOf(e5.presence_ref) < 0), h2 = s3.filter((e5) => r3.indexOf(e5.presence_ref) < 0);
        n3.length > 0 && (a2[e4] = n3), h2.length > 0 && (o2[e4] = h2);
      } else
        a2[e4] = t3;
    }), this.syncDiff(i2, { joins: a2, leaves: o2 }, s2, r2);
  }
  static syncDiff(e3, t2, s2, r2) {
    const { joins: i2, leaves: n2 } = { joins: this.transformState(t2.joins), leaves: this.transformState(t2.leaves) };
    return s2 || (s2 = () => {
    }), r2 || (r2 = () => {
    }), this.map(i2, (t3, r3) => {
      var i3;
      const n3 = null !== (i3 = e3[t3]) && void 0 !== i3 ? i3 : [];
      if (e3[t3] = this.cloneDeep(r3), n3.length > 0) {
        const s3 = e3[t3].map((e4) => e4.presence_ref), r4 = n3.filter((e4) => s3.indexOf(e4.presence_ref) < 0);
        e3[t3].unshift(...r4);
      }
      s2(t3, n3, r3);
    }), this.map(n2, (t3, s3) => {
      let i3 = e3[t3];
      if (!i3)
        return;
      const n3 = s3.map((e4) => e4.presence_ref);
      i3 = i3.filter((e4) => n3.indexOf(e4.presence_ref) < 0), e3[t3] = i3, r2(t3, i3, s3), 0 === i3.length && delete e3[t3];
    }), e3;
  }
  static map(e3, t2) {
    return Object.getOwnPropertyNames(e3).map((s2) => t2(s2, e3[s2]));
  }
  static transformState(e3) {
    return e3 = this.cloneDeep(e3), Object.getOwnPropertyNames(e3).reduce((t2, s2) => {
      const r2 = e3[s2];
      return t2[s2] = "metas" in r2 ? r2.metas.map((e4) => (e4.presence_ref = e4.phx_ref, delete e4.phx_ref, delete e4.phx_ref_prev, e4)) : r2, t2;
    }, {});
  }
  static cloneDeep(e3) {
    return JSON.parse(JSON.stringify(e3));
  }
  onJoin(e3) {
    this.caller.onJoin = e3;
  }
  onLeave(e3) {
    this.caller.onLeave = e3;
  }
  onSync(e3) {
    this.caller.onSync = e3;
  }
  inPendingSyncState() {
    return !this.joinRef || this.joinRef !== this.channel._joinRef();
  }
}
!function(e3) {
  e3.ALL = "*", e3.INSERT = "INSERT", e3.UPDATE = "UPDATE", e3.DELETE = "DELETE";
}(dt || (dt = {})), function(e3) {
  e3.BROADCAST = "broadcast", e3.PRESENCE = "presence", e3.POSTGRES_CHANGES = "postgres_changes";
}(ft || (ft = {})), function(e3) {
  e3.SUBSCRIBED = "SUBSCRIBED", e3.TIMED_OUT = "TIMED_OUT", e3.CLOSED = "CLOSED", e3.CHANNEL_ERROR = "CHANNEL_ERROR";
}(pt || (pt = {}));
const _t = Je;
class yt {
  constructor(e3, t2 = { config: {} }, s2) {
    this.topic = e3, this.params = t2, this.socket = s2, this.bindings = {}, this.state = Je.closed, this.joinedOnce = false, this.pushBuffer = [], this.subTopic = e3.replace(/^realtime:/i, ""), this.params.config = Object.assign({ broadcast: { ack: false, self: false }, presence: { key: "" }, private: false }, t2.config), this.timeout = this.socket.timeout, this.joinPush = new ct(this, Ve.join, this.params, this.timeout), this.rejoinTimer = new Ze(() => this._rejoinUntilConnected(), this.socket.reconnectAfterMs), this.joinPush.receive("ok", () => {
      this.state = Je.joined, this.rejoinTimer.reset(), this.pushBuffer.forEach((e4) => e4.send()), this.pushBuffer = [];
    }), this._onClose(() => {
      this.rejoinTimer.reset(), this.socket.log("channel", `close ${this.topic} ${this._joinRef()}`), this.state = Je.closed, this.socket._remove(this);
    }), this._onError((e4) => {
      this._isLeaving() || this._isClosed() || (this.socket.log("channel", `error ${this.topic}`, e4), this.state = Je.errored, this.rejoinTimer.scheduleTimeout());
    }), this.joinPush.receive("timeout", () => {
      this._isJoining() && (this.socket.log("channel", `timeout ${this.topic}`, this.joinPush.timeout), this.state = Je.errored, this.rejoinTimer.scheduleTimeout());
    }), this._on(Ve.reply, {}, (e4, t3) => {
      this._trigger(this._replyEventName(t3), e4);
    }), this.presence = new gt(this), this.broadcastEndpointURL = lt(this.socket.endPoint) + "/api/broadcast";
  }
  subscribe(e3, t2 = this.timeout) {
    var s2, r2;
    if (this.socket.isConnected() || this.socket.connect(), this.joinedOnce)
      throw "tried to subscribe multiple times. 'subscribe' can only be called a single time per channel instance";
    {
      const { config: { broadcast: i2, presence: n2, private: a2 } } = this.params;
      this._onError((t3) => e3 && e3("CHANNEL_ERROR", t3)), this._onClose(() => e3 && e3("CLOSED"));
      const o2 = {}, h2 = { broadcast: i2, presence: n2, postgres_changes: null !== (r2 = null === (s2 = this.bindings.postgres_changes) || void 0 === s2 ? void 0 : s2.map((e4) => e4.filter)) && void 0 !== r2 ? r2 : [], private: a2 };
      this.socket.accessToken && (o2.access_token = this.socket.accessToken), this.updateJoinPayload(Object.assign({ config: h2 }, o2)), this.joinedOnce = true, this._rejoin(t2), this.joinPush.receive("ok", ({ postgres_changes: t3 }) => {
        var s3;
        if (this.socket.accessToken && this.socket.setAuth(this.socket.accessToken), void 0 !== t3) {
          const r3 = this.bindings.postgres_changes, i3 = null !== (s3 = null == r3 ? void 0 : r3.length) && void 0 !== s3 ? s3 : 0, n3 = [];
          for (let s4 = 0; s4 < i3; s4++) {
            const i4 = r3[s4], { filter: { event: a3, schema: o3, table: h3, filter: l2 } } = i4, c2 = t3 && t3[s4];
            if (!c2 || c2.event !== a3 || c2.schema !== o3 || c2.table !== h3 || c2.filter !== l2)
              return this.unsubscribe(), void (e3 && e3("CHANNEL_ERROR", new Error("mismatch between server and client bindings for postgres changes")));
            n3.push(Object.assign(Object.assign({}, i4), { id: c2.id }));
          }
          return this.bindings.postgres_changes = n3, void (e3 && e3("SUBSCRIBED"));
        }
        e3 && e3("SUBSCRIBED");
      }).receive("error", (t3) => {
        e3 && e3("CHANNEL_ERROR", new Error(JSON.stringify(Object.values(t3).join(", ") || "error")));
      }).receive("timeout", () => {
        e3 && e3("TIMED_OUT");
      });
    }
    return this;
  }
  presenceState() {
    return this.presence.state;
  }
  async track(e3, t2 = {}) {
    return await this.send({ type: "presence", event: "track", payload: e3 }, t2.timeout || this.timeout);
  }
  async untrack(e3 = {}) {
    return await this.send({ type: "presence", event: "untrack" }, e3);
  }
  on(e3, t2, s2) {
    return this._on(e3, t2, s2);
  }
  async send(e3, t2 = {}) {
    var s2, r2;
    if (this._canPush() || "broadcast" !== e3.type)
      return new Promise((s3) => {
        var r3, i2, n2;
        const a2 = this._push(e3.type, e3, t2.timeout || this.timeout);
        "broadcast" !== e3.type || (null === (n2 = null === (i2 = null === (r3 = this.params) || void 0 === r3 ? void 0 : r3.config) || void 0 === i2 ? void 0 : i2.broadcast) || void 0 === n2 ? void 0 : n2.ack) || s3("ok"), a2.receive("ok", () => s3("ok")), a2.receive("error", () => s3("error")), a2.receive("timeout", () => s3("timed out"));
      });
    {
      const { event: i2, payload: n2 } = e3, a2 = { method: "POST", headers: { Authorization: this.socket.accessToken ? `Bearer ${this.socket.accessToken}` : "", apikey: this.socket.apiKey ? this.socket.apiKey : "", "Content-Type": "application/json" }, body: JSON.stringify({ messages: [{ topic: this.subTopic, event: i2, payload: n2 }] }) };
      try {
        const e4 = await this._fetchWithTimeout(this.broadcastEndpointURL, a2, null !== (s2 = t2.timeout) && void 0 !== s2 ? s2 : this.timeout);
        return await (null === (r2 = e4.body) || void 0 === r2 ? void 0 : r2.cancel()), e4.ok ? "ok" : "error";
      } catch (e4) {
        return "AbortError" === e4.name ? "timed out" : "error";
      }
    }
  }
  updateJoinPayload(e3) {
    this.joinPush.updatePayload(e3);
  }
  unsubscribe(e3 = this.timeout) {
    this.state = Je.leaving;
    const t2 = () => {
      this.socket.log("channel", `leave ${this.topic}`), this._trigger(Ve.close, "leave", this._joinRef());
    };
    return this.rejoinTimer.reset(), this.joinPush.destroy(), new Promise((s2) => {
      const r2 = new ct(this, Ve.leave, {}, e3);
      r2.receive("ok", () => {
        t2(), s2("ok");
      }).receive("timeout", () => {
        t2(), s2("timed out");
      }).receive("error", () => {
        s2("error");
      }), r2.send(), this._canPush() || r2.trigger("ok", {});
    });
  }
  async _fetchWithTimeout(e3, t2, s2) {
    const r2 = new AbortController(), i2 = setTimeout(() => r2.abort(), s2), n2 = await this.socket.fetch(e3, Object.assign(Object.assign({}, t2), { signal: r2.signal }));
    return clearTimeout(i2), n2;
  }
  _push(e3, t2, s2 = this.timeout) {
    if (!this.joinedOnce)
      throw `tried to push '${e3}' to '${this.topic}' before joining. Use channel.subscribe() before pushing events`;
    let r2 = new ct(this, e3, t2, s2);
    return this._canPush() ? r2.send() : (r2.startTimeout(), this.pushBuffer.push(r2)), r2;
  }
  _onMessage(e3, t2, s2) {
    return t2;
  }
  _isMember(e3) {
    return this.topic === e3;
  }
  _joinRef() {
    return this.joinPush.ref;
  }
  _trigger(e3, t2, s2) {
    var r2, i2;
    const n2 = e3.toLocaleLowerCase(), { close: a2, error: o2, leave: h2, join: l2 } = Ve;
    if (s2 && [a2, o2, h2, l2].indexOf(n2) >= 0 && s2 !== this._joinRef())
      return;
    let c2 = this._onMessage(n2, t2, s2);
    if (t2 && !c2)
      throw "channel onMessage callbacks must return the payload, modified or unmodified";
    ["insert", "update", "delete"].includes(n2) ? null === (r2 = this.bindings.postgres_changes) || void 0 === r2 || r2.filter((e4) => {
      var t3, s3, r3;
      return "*" === (null === (t3 = e4.filter) || void 0 === t3 ? void 0 : t3.event) || (null === (r3 = null === (s3 = e4.filter) || void 0 === s3 ? void 0 : s3.event) || void 0 === r3 ? void 0 : r3.toLocaleLowerCase()) === n2;
    }).map((e4) => e4.callback(c2, s2)) : null === (i2 = this.bindings[n2]) || void 0 === i2 || i2.filter((e4) => {
      var s3, r3, i3, a3, o3, h3;
      if (["broadcast", "presence", "postgres_changes"].includes(n2)) {
        if ("id" in e4) {
          const n3 = e4.id, a4 = null === (s3 = e4.filter) || void 0 === s3 ? void 0 : s3.event;
          return n3 && (null === (r3 = t2.ids) || void 0 === r3 ? void 0 : r3.includes(n3)) && ("*" === a4 || (null == a4 ? void 0 : a4.toLocaleLowerCase()) === (null === (i3 = t2.data) || void 0 === i3 ? void 0 : i3.type.toLocaleLowerCase()));
        }
        {
          const s4 = null === (o3 = null === (a3 = null == e4 ? void 0 : e4.filter) || void 0 === a3 ? void 0 : a3.event) || void 0 === o3 ? void 0 : o3.toLocaleLowerCase();
          return "*" === s4 || s4 === (null === (h3 = null == t2 ? void 0 : t2.event) || void 0 === h3 ? void 0 : h3.toLocaleLowerCase());
        }
      }
      return e4.type.toLocaleLowerCase() === n2;
    }).map((e4) => {
      if ("object" == typeof c2 && "ids" in c2) {
        const e5 = c2.data, { schema: t3, table: s3, commit_timestamp: r3, type: i3, errors: n3 } = e5, a3 = { schema: t3, table: s3, commit_timestamp: r3, eventType: i3, new: {}, old: {}, errors: n3 };
        c2 = Object.assign(Object.assign({}, a3), this._getPayloadRecords(e5));
      }
      e4.callback(c2, s2);
    });
  }
  _isClosed() {
    return this.state === Je.closed;
  }
  _isJoined() {
    return this.state === Je.joined;
  }
  _isJoining() {
    return this.state === Je.joining;
  }
  _isLeaving() {
    return this.state === Je.leaving;
  }
  _replyEventName(e3) {
    return `chan_reply_${e3}`;
  }
  _on(e3, t2, s2) {
    const r2 = e3.toLocaleLowerCase(), i2 = { type: r2, filter: t2, callback: s2 };
    return this.bindings[r2] ? this.bindings[r2].push(i2) : this.bindings[r2] = [i2], this;
  }
  _off(e3, t2) {
    const s2 = e3.toLocaleLowerCase();
    return this.bindings[s2] = this.bindings[s2].filter((e4) => {
      var r2;
      return !((null === (r2 = e4.type) || void 0 === r2 ? void 0 : r2.toLocaleLowerCase()) === s2 && yt.isEqual(e4.filter, t2));
    }), this;
  }
  static isEqual(e3, t2) {
    if (Object.keys(e3).length !== Object.keys(t2).length)
      return false;
    for (const s2 in e3)
      if (e3[s2] !== t2[s2])
        return false;
    return true;
  }
  _rejoinUntilConnected() {
    this.rejoinTimer.scheduleTimeout(), this.socket.isConnected() && this._rejoin();
  }
  _onClose(e3) {
    this._on(Ve.close, {}, e3);
  }
  _onError(e3) {
    this._on(Ve.error, {}, (t2) => e3(t2));
  }
  _canPush() {
    return this.socket.isConnected() && this._isJoined();
  }
  _rejoin(e3 = this.timeout) {
    this._isLeaving() || (this.socket._leaveOpenTopic(this.topic), this.state = Je.joining, this.joinPush.resend(e3));
  }
  _getPayloadRecords(e3) {
    const t2 = { new: {}, old: {} };
    return "INSERT" !== e3.type && "UPDATE" !== e3.type || (t2.new = et(e3.columns, e3.record)), "UPDATE" !== e3.type && "DELETE" !== e3.type || (t2.old = et(e3.columns, e3.old_record)), t2;
  }
}
const mt = () => {
}, vt = "undefined" != typeof WebSocket;
class bt {
  constructor(e3, t2) {
    var s2;
    this.accessToken = null, this.apiKey = null, this.channels = [], this.endPoint = "", this.httpEndpoint = "", this.headers = Ge, this.params = {}, this.timeout = 1e4, this.heartbeatIntervalMs = 3e4, this.heartbeatTimer = void 0, this.pendingHeartbeatRef = null, this.ref = 0, this.logger = mt, this.conn = null, this.sendBuffer = [], this.serializer = new Xe(), this.stateChangeCallbacks = { open: [], close: [], error: [], message: [] }, this._resolveFetch = (e4) => {
      let t3;
      return t3 = e4 || ("undefined" == typeof fetch ? (...e5) => import("./fetch-648a91f6.js").then((e6) => e6.$).then(({ default: t4 }) => t4(...e5)) : fetch), (...e5) => t3(...e5);
    }, this.endPoint = `${e3}/${We.websocket}`, this.httpEndpoint = lt(e3), (null == t2 ? void 0 : t2.transport) ? this.transport = t2.transport : this.transport = null, (null == t2 ? void 0 : t2.params) && (this.params = t2.params), (null == t2 ? void 0 : t2.headers) && (this.headers = Object.assign(Object.assign({}, this.headers), t2.headers)), (null == t2 ? void 0 : t2.timeout) && (this.timeout = t2.timeout), (null == t2 ? void 0 : t2.logger) && (this.logger = t2.logger), (null == t2 ? void 0 : t2.heartbeatIntervalMs) && (this.heartbeatIntervalMs = t2.heartbeatIntervalMs);
    const r2 = null === (s2 = null == t2 ? void 0 : t2.params) || void 0 === s2 ? void 0 : s2.apikey;
    r2 && (this.accessToken = r2, this.apiKey = r2), this.reconnectAfterMs = (null == t2 ? void 0 : t2.reconnectAfterMs) ? t2.reconnectAfterMs : (e4) => [1e3, 2e3, 5e3, 1e4][e4 - 1] || 1e4, this.encode = (null == t2 ? void 0 : t2.encode) ? t2.encode : (e4, t3) => t3(JSON.stringify(e4)), this.decode = (null == t2 ? void 0 : t2.decode) ? t2.decode : this.serializer.decode.bind(this.serializer), this.reconnectTimer = new Ze(async () => {
      this.disconnect(), this.connect();
    }, this.reconnectAfterMs), this.fetch = this._resolveFetch(null == t2 ? void 0 : t2.fetch);
  }
  connect() {
    if (!this.conn)
      if (this.transport)
        this.conn = new this.transport(this._endPointURL(), void 0, { headers: this.headers });
      else {
        if (vt)
          return this.conn = new WebSocket(this._endPointURL()), void this.setupConnection();
        this.conn = new wt(this._endPointURL(), void 0, { close: () => {
          this.conn = null;
        } }), import("./browser-32fb580c.js").then((e3) => e3.b).then(({ default: e3 }) => {
          this.conn = new e3(this._endPointURL(), void 0, { headers: this.headers }), this.setupConnection();
        });
      }
  }
  disconnect(e3, t2) {
    this.conn && (this.conn.onclose = function() {
    }, e3 ? this.conn.close(e3, null != t2 ? t2 : "") : this.conn.close(), this.conn = null, this.heartbeatTimer && clearInterval(this.heartbeatTimer), this.reconnectTimer.reset());
  }
  getChannels() {
    return this.channels;
  }
  async removeChannel(e3) {
    const t2 = await e3.unsubscribe();
    return 0 === this.channels.length && this.disconnect(), t2;
  }
  async removeAllChannels() {
    const e3 = await Promise.all(this.channels.map((e4) => e4.unsubscribe()));
    return this.disconnect(), e3;
  }
  log(e3, t2, s2) {
    this.logger(e3, t2, s2);
  }
  connectionState() {
    switch (this.conn && this.conn.readyState) {
      case He.connecting:
        return Ye.Connecting;
      case He.open:
        return Ye.Open;
      case He.closing:
        return Ye.Closing;
      default:
        return Ye.Closed;
    }
  }
  isConnected() {
    return this.connectionState() === Ye.Open;
  }
  channel(e3, t2 = { config: {} }) {
    const s2 = new yt(`realtime:${e3}`, t2, this);
    return this.channels.push(s2), s2;
  }
  push(e3) {
    const { topic: t2, event: s2, payload: r2, ref: i2 } = e3, n2 = () => {
      this.encode(e3, (e4) => {
        var t3;
        null === (t3 = this.conn) || void 0 === t3 || t3.send(e4);
      });
    };
    this.log("push", `${t2} ${s2} (${i2})`, r2), this.isConnected() ? n2() : this.sendBuffer.push(n2);
  }
  setAuth(e3) {
    this.accessToken = e3, this.channels.forEach((t2) => {
      e3 && t2.updateJoinPayload({ access_token: e3 }), t2.joinedOnce && t2._isJoined() && t2._push(Ve.access_token, { access_token: e3 });
    });
  }
  _makeRef() {
    let e3 = this.ref + 1;
    return e3 === this.ref ? this.ref = 0 : this.ref = e3, this.ref.toString();
  }
  _leaveOpenTopic(e3) {
    let t2 = this.channels.find((t3) => t3.topic === e3 && (t3._isJoined() || t3._isJoining()));
    t2 && (this.log("transport", `leaving duplicate topic "${e3}"`), t2.unsubscribe());
  }
  _remove(e3) {
    this.channels = this.channels.filter((t2) => t2._joinRef() !== e3._joinRef());
  }
  setupConnection() {
    this.conn && (this.conn.binaryType = "arraybuffer", this.conn.onopen = () => this._onConnOpen(), this.conn.onerror = (e3) => this._onConnError(e3), this.conn.onmessage = (e3) => this._onConnMessage(e3), this.conn.onclose = (e3) => this._onConnClose(e3));
  }
  _endPointURL() {
    return this._appendParams(this.endPoint, Object.assign({}, this.params, { vsn: "1.0.0" }));
  }
  _onConnMessage(e3) {
    this.decode(e3.data, (e4) => {
      let { topic: t2, event: s2, payload: r2, ref: i2 } = e4;
      (i2 && i2 === this.pendingHeartbeatRef || s2 === (null == r2 ? void 0 : r2.type)) && (this.pendingHeartbeatRef = null), this.log("receive", `${r2.status || ""} ${t2} ${s2} ${i2 && "(" + i2 + ")" || ""}`, r2), this.channels.filter((e5) => e5._isMember(t2)).forEach((e5) => e5._trigger(s2, r2, i2)), this.stateChangeCallbacks.message.forEach((t3) => t3(e4));
    });
  }
  _onConnOpen() {
    this.log("transport", `connected to ${this._endPointURL()}`), this._flushSendBuffer(), this.reconnectTimer.reset(), this.heartbeatTimer && clearInterval(this.heartbeatTimer), this.heartbeatTimer = setInterval(() => this._sendHeartbeat(), this.heartbeatIntervalMs), this.stateChangeCallbacks.open.forEach((e3) => e3());
  }
  _onConnClose(e3) {
    this.log("transport", "close", e3), this._triggerChanError(), this.heartbeatTimer && clearInterval(this.heartbeatTimer), this.reconnectTimer.scheduleTimeout(), this.stateChangeCallbacks.close.forEach((t2) => t2(e3));
  }
  _onConnError(e3) {
    this.log("transport", e3.message), this._triggerChanError(), this.stateChangeCallbacks.error.forEach((t2) => t2(e3));
  }
  _triggerChanError() {
    this.channels.forEach((e3) => e3._trigger(Ve.error));
  }
  _appendParams(e3, t2) {
    if (0 === Object.keys(t2).length)
      return e3;
    const s2 = e3.match(/\?/) ? "&" : "?";
    return `${e3}${s2}${new URLSearchParams(t2)}`;
  }
  _flushSendBuffer() {
    this.isConnected() && this.sendBuffer.length > 0 && (this.sendBuffer.forEach((e3) => e3()), this.sendBuffer = []);
  }
  _sendHeartbeat() {
    var e3;
    if (this.isConnected()) {
      if (this.pendingHeartbeatRef)
        return this.pendingHeartbeatRef = null, this.log("transport", "heartbeat timeout. Attempting to re-establish connection"), void (null === (e3 = this.conn) || void 0 === e3 || e3.close(1e3, "hearbeat timeout"));
      this.pendingHeartbeatRef = this._makeRef(), this.push({ topic: "phoenix", event: "heartbeat", payload: {}, ref: this.pendingHeartbeatRef }), this.setAuth(this.accessToken);
    }
  }
}
class wt {
  constructor(e3, t2, s2) {
    this.binaryType = "arraybuffer", this.onclose = () => {
    }, this.onerror = () => {
    }, this.onmessage = () => {
    }, this.onopen = () => {
    }, this.readyState = He.connecting, this.send = () => {
    }, this.url = null, this.url = e3, this.close = s2.close;
  }
}
var kt = globalThis && globalThis.__awaiter || function(e3, t2, s2, r2) {
  return new (s2 || (s2 = Promise))(function(i2, n2) {
    function a2(e4) {
      try {
        h2(r2.next(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function o2(e4) {
      try {
        h2(r2.throw(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function h2(e4) {
      var t3;
      e4.done ? i2(e4.value) : (t3 = e4.value, t3 instanceof s2 ? t3 : new s2(function(e5) {
        e5(t3);
      })).then(a2, o2);
    }
    h2((r2 = r2.apply(e3, t2 || [])).next());
  });
};
const Tt = { limit: 100, offset: 0, sortBy: { column: "name", order: "asc" } }, St = { cacheControl: "3600", contentType: "text/plain;charset=UTF-8", upsert: false };
class Et {
  constructor(e3, s2 = {}, r2, i2) {
    this.url = e3, this.headers = s2, this.bucketId = r2, this.fetch = t(i2);
  }
  uploadOrUpdate(e3, t2, r2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        let s2;
        const n2 = Object.assign(Object.assign({}, St), i2);
        let a2 = Object.assign(Object.assign({}, this.headers), "POST" === e3 && { "x-upsert": String(n2.upsert) });
        const o2 = n2.metadata;
        "undefined" != typeof Blob && r2 instanceof Blob ? (s2 = new FormData(), s2.append("cacheControl", n2.cacheControl), s2.append("", r2), o2 && s2.append("metadata", this.encodeMetadata(o2))) : "undefined" != typeof FormData && r2 instanceof FormData ? (s2 = r2, s2.append("cacheControl", n2.cacheControl), o2 && s2.append("metadata", this.encodeMetadata(o2))) : (s2 = r2, a2["cache-control"] = `max-age=${n2.cacheControl}`, a2["content-type"] = n2.contentType, o2 && (a2["x-metadata"] = this.toBase64(this.encodeMetadata(o2)))), (null == i2 ? void 0 : i2.headers) && (a2 = Object.assign(Object.assign({}, a2), i2.headers));
        const h2 = this._removeEmptyFolders(t2), l2 = this._getFinalPath(h2), c2 = yield this.fetch(`${this.url}/object/${l2}`, Object.assign({ method: e3, body: s2, headers: a2 }, (null == n2 ? void 0 : n2.duplex) ? { duplex: n2.duplex } : {})), u2 = yield c2.json();
        if (c2.ok)
          return { data: { path: h2, id: u2.Id, fullPath: u2.Key }, error: null };
        return { data: null, error: u2 };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  upload(e3, t2, s2) {
    return kt(this, void 0, void 0, function* () {
      return this.uploadOrUpdate("POST", e3, t2, s2);
    });
  }
  uploadToSignedUrl(e3, t2, r2, i2) {
    return kt(this, void 0, void 0, function* () {
      const n2 = this._removeEmptyFolders(e3), a2 = this._getFinalPath(n2), o2 = new URL(this.url + `/object/upload/sign/${a2}`);
      o2.searchParams.set("token", t2);
      try {
        let e4;
        const t3 = Object.assign({ upsert: St.upsert }, i2), s2 = Object.assign(Object.assign({}, this.headers), { "x-upsert": String(t3.upsert) });
        "undefined" != typeof Blob && r2 instanceof Blob ? (e4 = new FormData(), e4.append("cacheControl", t3.cacheControl), e4.append("", r2)) : "undefined" != typeof FormData && r2 instanceof FormData ? (e4 = r2, e4.append("cacheControl", t3.cacheControl)) : (e4 = r2, s2["cache-control"] = `max-age=${t3.cacheControl}`, s2["content-type"] = t3.contentType);
        const a3 = yield this.fetch(o2.toString(), { method: "PUT", body: e4, headers: s2 }), h2 = yield a3.json();
        if (a3.ok)
          return { data: { path: n2, fullPath: h2.Key }, error: null };
        return { data: null, error: h2 };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  createSignedUploadUrl(e3, t2) {
    return kt(this, void 0, void 0, function* () {
      try {
        let s2 = this._getFinalPath(e3);
        const n2 = Object.assign({}, this.headers);
        (null == t2 ? void 0 : t2.upsert) && (n2["x-upsert"] = "true");
        const a2 = yield r(this.fetch, `${this.url}/object/upload/sign/${s2}`, {}, { headers: n2 }), o2 = new URL(this.url + a2.url), h2 = o2.searchParams.get("token");
        if (!h2)
          throw new i("No token returned by API");
        return { data: { signedUrl: o2.toString(), path: e3, token: h2 }, error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  update(e3, t2, s2) {
    return kt(this, void 0, void 0, function* () {
      return this.uploadOrUpdate("PUT", e3, t2, s2);
    });
  }
  move(e3, t2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        return { data: yield r(this.fetch, `${this.url}/object/move`, { bucketId: this.bucketId, sourceKey: e3, destinationKey: t2, destinationBucket: null == i2 ? void 0 : i2.destinationBucket }, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  copy(e3, t2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        return { data: { path: (yield r(this.fetch, `${this.url}/object/copy`, { bucketId: this.bucketId, sourceKey: e3, destinationKey: t2, destinationBucket: null == i2 ? void 0 : i2.destinationBucket }, { headers: this.headers })).Key }, error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  createSignedUrl(e3, t2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        let s2 = this._getFinalPath(e3), n2 = yield r(this.fetch, `${this.url}/object/sign/${s2}`, Object.assign({ expiresIn: t2 }, (null == i2 ? void 0 : i2.transform) ? { transform: i2.transform } : {}), { headers: this.headers });
        const a2 = (null == i2 ? void 0 : i2.download) ? `&download=${true === i2.download ? "" : i2.download}` : "";
        return n2 = { signedUrl: encodeURI(`${this.url}${n2.signedURL}${a2}`) }, { data: n2, error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  createSignedUrls(e3, t2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        const s2 = yield r(this.fetch, `${this.url}/object/sign/${this.bucketId}`, { expiresIn: t2, paths: e3 }, { headers: this.headers }), n2 = (null == i2 ? void 0 : i2.download) ? `&download=${true === i2.download ? "" : i2.download}` : "";
        return { data: s2.map((e4) => Object.assign(Object.assign({}, e4), { signedUrl: e4.signedURL ? encodeURI(`${this.url}${e4.signedURL}${n2}`) : null })), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  download(e3, t2) {
    return kt(this, void 0, void 0, function* () {
      const r2 = void 0 !== (null == t2 ? void 0 : t2.transform) ? "render/image/authenticated" : "object", i2 = this.transformOptsToQueryString((null == t2 ? void 0 : t2.transform) || {}), a2 = i2 ? `?${i2}` : "";
      try {
        const t3 = this._getFinalPath(e3), s2 = yield n(this.fetch, `${this.url}/${r2}/${t3}${a2}`, { headers: this.headers, noResolveJson: true });
        return { data: yield s2.blob(), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  info(e3) {
    return kt(this, void 0, void 0, function* () {
      const t2 = this._getFinalPath(e3);
      try {
        const e4 = yield n(this.fetch, `${this.url}/object/info/${t2}`, { headers: this.headers });
        return { data: a(e4), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  exists(e3) {
    return kt(this, void 0, void 0, function* () {
      const t2 = this._getFinalPath(e3);
      try {
        return yield o(this.fetch, `${this.url}/object/${t2}`, { headers: this.headers }), { data: true, error: null };
      } catch (e4) {
        if (s(e4) && e4 instanceof h) {
          const t3 = e4.originalError;
          if ([400, 404].includes(null == t3 ? void 0 : t3.status))
            return { data: false, error: e4 };
        }
        throw e4;
      }
    });
  }
  getPublicUrl(e3, t2) {
    const s2 = this._getFinalPath(e3), r2 = [], i2 = (null == t2 ? void 0 : t2.download) ? `download=${true === t2.download ? "" : t2.download}` : "";
    "" !== i2 && r2.push(i2);
    const n2 = void 0 !== (null == t2 ? void 0 : t2.transform) ? "render/image" : "object", a2 = this.transformOptsToQueryString((null == t2 ? void 0 : t2.transform) || {});
    "" !== a2 && r2.push(a2);
    let o2 = r2.join("&");
    return "" !== o2 && (o2 = `?${o2}`), { data: { publicUrl: encodeURI(`${this.url}/${n2}/public/${s2}${o2}`) } };
  }
  remove(e3) {
    return kt(this, void 0, void 0, function* () {
      try {
        return { data: yield l(this.fetch, `${this.url}/object/${this.bucketId}`, { prefixes: e3 }, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  list(e3, t2, i2) {
    return kt(this, void 0, void 0, function* () {
      try {
        const s2 = Object.assign(Object.assign(Object.assign({}, Tt), t2), { prefix: e3 || "" });
        return { data: yield r(this.fetch, `${this.url}/object/list/${this.bucketId}`, s2, { headers: this.headers }, i2), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  encodeMetadata(e3) {
    return JSON.stringify(e3);
  }
  toBase64(e3) {
    return "undefined" != typeof Buffer ? Buffer.from(e3).toString("base64") : btoa(e3);
  }
  _getFinalPath(e3) {
    return `${this.bucketId}/${e3}`;
  }
  _removeEmptyFolders(e3) {
    return e3.replace(/^\/|\/$/g, "").replace(/\/+/g, "/");
  }
  transformOptsToQueryString(e3) {
    const t2 = [];
    return e3.width && t2.push(`width=${e3.width}`), e3.height && t2.push(`height=${e3.height}`), e3.resize && t2.push(`resize=${e3.resize}`), e3.format && t2.push(`format=${e3.format}`), e3.quality && t2.push(`quality=${e3.quality}`), t2.join("&");
  }
}
const Pt = { "X-Client-Info": "storage-js/2.7.0" };
var jt = globalThis && globalThis.__awaiter || function(e3, t2, s2, r2) {
  return new (s2 || (s2 = Promise))(function(i2, n2) {
    function a2(e4) {
      try {
        h2(r2.next(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function o2(e4) {
      try {
        h2(r2.throw(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function h2(e4) {
      var t3;
      e4.done ? i2(e4.value) : (t3 = e4.value, t3 instanceof s2 ? t3 : new s2(function(e5) {
        e5(t3);
      })).then(a2, o2);
    }
    h2((r2 = r2.apply(e3, t2 || [])).next());
  });
};
class $t {
  constructor(e3, s2 = {}, r2) {
    this.url = e3, this.headers = Object.assign(Object.assign({}, Pt), s2), this.fetch = t(r2);
  }
  listBuckets() {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield n(this.fetch, `${this.url}/bucket`, { headers: this.headers }), error: null };
      } catch (e3) {
        if (s(e3))
          return { data: null, error: e3 };
        throw e3;
      }
    });
  }
  getBucket(e3) {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield n(this.fetch, `${this.url}/bucket/${e3}`, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  createBucket(e3, t2 = { public: false }) {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield r(this.fetch, `${this.url}/bucket`, { id: e3, name: e3, public: t2.public, file_size_limit: t2.fileSizeLimit, allowed_mime_types: t2.allowedMimeTypes }, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  updateBucket(e3, t2) {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield c(this.fetch, `${this.url}/bucket/${e3}`, { id: e3, name: e3, public: t2.public, file_size_limit: t2.fileSizeLimit, allowed_mime_types: t2.allowedMimeTypes }, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  emptyBucket(e3) {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield r(this.fetch, `${this.url}/bucket/${e3}/empty`, {}, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  deleteBucket(e3) {
    return jt(this, void 0, void 0, function* () {
      try {
        return { data: yield l(this.fetch, `${this.url}/bucket/${e3}`, {}, { headers: this.headers }), error: null };
      } catch (e4) {
        if (s(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
}
class Ot extends $t {
  constructor(e3, t2 = {}, s2) {
    super(e3, t2, s2);
  }
  from(e3) {
    return new Et(this.url, this.headers, e3, this.fetch);
  }
}
let At = "";
At = "undefined" != typeof Deno ? "deno" : "undefined" != typeof document ? "web" : "undefined" != typeof navigator && "ReactNative" === navigator.product ? "react-native" : "node";
const Ct = { headers: { "X-Client-Info": `supabase-js-${At}/2.45.4` } }, Rt = { schema: "public" }, It = { autoRefreshToken: true, persistSession: true, detectSessionInUrl: true, flowType: "implicit" }, Lt = {};
var xt = globalThis && globalThis.__awaiter || function(e3, t2, s2, r2) {
  return new (s2 || (s2 = Promise))(function(i2, n2) {
    function a2(e4) {
      try {
        h2(r2.next(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function o2(e4) {
      try {
        h2(r2.throw(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function h2(e4) {
      var t3;
      e4.done ? i2(e4.value) : (t3 = e4.value, t3 instanceof s2 ? t3 : new s2(function(e5) {
        e5(t3);
      })).then(a2, o2);
    }
    h2((r2 = r2.apply(e3, t2 || [])).next());
  });
};
var Ut = globalThis && globalThis.__rest || function(e3, t2) {
  var s2 = {};
  for (var r2 in e3)
    Object.prototype.hasOwnProperty.call(e3, r2) && t2.indexOf(r2) < 0 && (s2[r2] = e3[r2]);
  if (null != e3 && "function" == typeof Object.getOwnPropertySymbols) {
    var i2 = 0;
    for (r2 = Object.getOwnPropertySymbols(e3); i2 < r2.length; i2++)
      t2.indexOf(r2[i2]) < 0 && Object.prototype.propertyIsEnumerable.call(e3, r2[i2]) && (s2[r2[i2]] = e3[r2[i2]]);
  }
  return s2;
};
class Dt {
  constructor({ url: e3 = "", headers: t2 = {}, fetch: s2 }) {
    this.url = e3, this.headers = t2, this.fetch = u(s2), this.mfa = { listFactors: this._listFactors.bind(this), deleteFactor: this._deleteFactor.bind(this) };
  }
  async signOut(e3, t2 = "global") {
    try {
      return await d(this.fetch, "POST", `${this.url}/logout?scope=${t2}`, { headers: this.headers, jwt: e3, noResolveJson: true }), { data: null, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async inviteUserByEmail(e3, t2 = {}) {
    try {
      return await d(this.fetch, "POST", `${this.url}/invite`, { body: { email: e3, data: t2.data }, headers: this.headers, redirectTo: t2.redirectTo, xform: g });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async generateLink(e3) {
    try {
      const { options: t2 } = e3, s2 = Ut(e3, ["options"]), r2 = Object.assign(Object.assign({}, s2), t2);
      return "newEmail" in s2 && (r2.new_email = null == s2 ? void 0 : s2.newEmail, delete r2.newEmail), await d(this.fetch, "POST", `${this.url}/admin/generate_link`, { body: r2, headers: this.headers, xform: _, redirectTo: null == t2 ? void 0 : t2.redirectTo });
    } catch (e4) {
      if (f(e4))
        return { data: { properties: null, user: null }, error: e4 };
      throw e4;
    }
  }
  async createUser(e3) {
    try {
      return await d(this.fetch, "POST", `${this.url}/admin/users`, { body: e3, headers: this.headers, xform: g });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async listUsers(e3) {
    var t2, s2, r2, i2, n2, a2, o2;
    try {
      const h2 = { nextPage: null, lastPage: 0, total: 0 }, l2 = await d(this.fetch, "GET", `${this.url}/admin/users`, { headers: this.headers, noResolveJson: true, query: { page: null !== (s2 = null === (t2 = null == e3 ? void 0 : e3.page) || void 0 === t2 ? void 0 : t2.toString()) && void 0 !== s2 ? s2 : "", per_page: null !== (i2 = null === (r2 = null == e3 ? void 0 : e3.perPage) || void 0 === r2 ? void 0 : r2.toString()) && void 0 !== i2 ? i2 : "" }, xform: p });
      if (l2.error)
        throw l2.error;
      const c2 = await l2.json(), u2 = null !== (n2 = l2.headers.get("x-total-count")) && void 0 !== n2 ? n2 : 0, f2 = null !== (o2 = null === (a2 = l2.headers.get("link")) || void 0 === a2 ? void 0 : a2.split(",")) && void 0 !== o2 ? o2 : [];
      return f2.length > 0 && (f2.forEach((e4) => {
        const t3 = parseInt(e4.split(";")[0].split("=")[1].substring(0, 1)), s3 = JSON.parse(e4.split(";")[1].split("=")[1]);
        h2[`${s3}Page`] = t3;
      }), h2.total = parseInt(u2)), { data: Object.assign(Object.assign({}, c2), h2), error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { users: [] }, error: e4 };
      throw e4;
    }
  }
  async getUserById(e3) {
    try {
      return await d(this.fetch, "GET", `${this.url}/admin/users/${e3}`, { headers: this.headers, xform: g });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async updateUserById(e3, t2) {
    try {
      return await d(this.fetch, "PUT", `${this.url}/admin/users/${e3}`, { body: t2, headers: this.headers, xform: g });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async deleteUser(e3, t2 = false) {
    try {
      return await d(this.fetch, "DELETE", `${this.url}/admin/users/${e3}`, { headers: this.headers, body: { should_soft_delete: t2 }, xform: g });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async _listFactors(e3) {
    try {
      const { data: t2, error: s2 } = await d(this.fetch, "GET", `${this.url}/admin/users/${e3.userId}/factors`, { headers: this.headers, xform: (e4) => ({ data: { factors: e4 }, error: null }) });
      return { data: t2, error: s2 };
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async _deleteFactor(e3) {
    try {
      return { data: await d(this.fetch, "DELETE", `${this.url}/admin/users/${e3.userId}/factors/${e3.id}`, { headers: this.headers }), error: null };
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
}
const Nt = { getItem: (e3) => y() ? globalThis.localStorage.getItem(e3) : null, setItem: (e3, t2) => {
  y() && globalThis.localStorage.setItem(e3, t2);
}, removeItem: (e3) => {
  y() && globalThis.localStorage.removeItem(e3);
} };
function Ft(e3 = {}) {
  return { getItem: (t2) => e3[t2] || null, setItem: (t2, s2) => {
    e3[t2] = s2;
  }, removeItem: (t2) => {
    delete e3[t2];
  } };
}
const Bt = { debug: !!(globalThis && y() && globalThis.localStorage && "true" === globalThis.localStorage.getItem("supabase.gotrue-js.locks.debug")) };
class Mt extends Error {
  constructor(e3) {
    super(e3), this.isAcquireTimeout = true;
  }
}
class qt extends Mt {
}
async function zt(e3, t2, s2) {
  const r2 = new globalThis.AbortController();
  return t2 > 0 && setTimeout(() => {
    r2.abort();
  }, t2), await globalThis.navigator.locks.request(e3, 0 === t2 ? { mode: "exclusive", ifAvailable: true } : { mode: "exclusive", signal: r2.signal }, async (r3) => {
    if (!r3) {
      if (0 === t2)
        throw new qt(`Acquiring an exclusive Navigator LockManager lock "${e3}" immediately failed`);
      if (Bt.debug)
        try {
          await globalThis.navigator.locks.query();
        } catch (e4) {
        }
      return await s2();
    }
    try {
      return await s2();
    } finally {
    }
  });
}
!function() {
  if ("object" != typeof globalThis)
    try {
      Object.defineProperty(Object.prototype, "__magic__", { get: function() {
        return this;
      }, configurable: true }), __magic__.globalThis = __magic__, delete Object.prototype.__magic__;
    } catch (e3) {
      "undefined" != typeof self && (self.globalThis = self);
    }
}();
const Kt = { url: M, storageKey: q, autoRefreshToken: true, persistSession: true, detectSessionInUrl: true, headers: z, flowType: "implicit", debug: false, hasCustomAuthorizationHeader: false }, Gt = 3e4;
async function Ht(e3, t2, s2) {
  return await s2();
}
class Jt {
  constructor(e3) {
    var t2, s2;
    this.memoryStorage = null, this.stateChangeEmitters = /* @__PURE__ */ new Map(), this.autoRefreshTicker = null, this.visibilityChangedCallback = null, this.refreshingDeferred = null, this.initializePromise = null, this.detectSessionInUrl = true, this.hasCustomAuthorizationHeader = false, this.suppressGetSessionWarning = false, this.lockAcquired = false, this.pendingInLock = [], this.broadcastChannel = null, this.logger = console.log, this.instanceID = Jt.nextInstanceID, Jt.nextInstanceID += 1, this.instanceID > 0 && m();
    const r2 = Object.assign(Object.assign({}, Kt), e3);
    if (this.logDebugMessages = !!r2.debug, "function" == typeof r2.debug && (this.logger = r2.debug), this.persistSession = r2.persistSession, this.storageKey = r2.storageKey, this.autoRefreshToken = r2.autoRefreshToken, this.admin = new Dt({ url: r2.url, headers: r2.headers, fetch: r2.fetch }), this.url = r2.url, this.headers = r2.headers, this.fetch = u(r2.fetch), this.lock = r2.lock || Ht, this.detectSessionInUrl = r2.detectSessionInUrl, this.flowType = r2.flowType, this.hasCustomAuthorizationHeader = r2.hasCustomAuthorizationHeader, r2.lock ? this.lock = r2.lock : m() && (null === (t2 = null === globalThis || void 0 === globalThis ? void 0 : globalThis.navigator) || void 0 === t2 ? void 0 : t2.locks) ? this.lock = zt : this.lock = Ht, this.mfa = { verify: this._verify.bind(this), enroll: this._enroll.bind(this), unenroll: this._unenroll.bind(this), challenge: this._challenge.bind(this), listFactors: this._listFactors.bind(this), challengeAndVerify: this._challengeAndVerify.bind(this), getAuthenticatorAssuranceLevel: this._getAuthenticatorAssuranceLevel.bind(this) }, this.persistSession ? r2.storage ? this.storage = r2.storage : y() ? this.storage = Nt : (this.memoryStorage = {}, this.storage = Ft(this.memoryStorage)) : (this.memoryStorage = {}, this.storage = Ft(this.memoryStorage)), m() && globalThis.BroadcastChannel && this.persistSession && this.storageKey) {
      try {
        this.broadcastChannel = new globalThis.BroadcastChannel(this.storageKey);
      } catch (e4) {
      }
      null === (s2 = this.broadcastChannel) || void 0 === s2 || s2.addEventListener("message", async (e4) => {
        this._debug("received broadcast notification from other tab or client", e4), await this._notifyAllSubscribers(e4.data.event, e4.data.session, false);
      });
    }
    this.initialize();
  }
  _debug(...e3) {
    return this.logDebugMessages && this.logger(`GoTrueClient@${this.instanceID} (${v}) ${(/* @__PURE__ */ new Date()).toISOString()}`, ...e3), this;
  }
  async initialize() {
    return this.initializePromise || (this.initializePromise = (async () => await this._acquireLock(-1, async () => await this._initialize()))()), await this.initializePromise;
  }
  async _initialize() {
    try {
      const e3 = !!m() && await this._isPKCEFlow();
      if (this._debug("#_initialize()", "begin", "is PKCE flow", e3), e3 || this.detectSessionInUrl && this._isImplicitGrantFlow()) {
        const { data: t2, error: s2 } = await this._getSessionFromURL(e3);
        if (s2)
          return this._debug("#_initialize()", "error detecting session from URL", s2), "Identity is already linked" === (null == s2 ? void 0 : s2.message) || "Identity is already linked to another user" === (null == s2 ? void 0 : s2.message) || await this._removeSession(), { error: s2 };
        const { session: r2, redirectType: i2 } = t2;
        return this._debug("#_initialize()", "detected session in URL", r2, "redirect type", i2), await this._saveSession(r2), setTimeout(async () => {
          "recovery" === i2 ? await this._notifyAllSubscribers("PASSWORD_RECOVERY", r2) : await this._notifyAllSubscribers("SIGNED_IN", r2);
        }, 0), { error: null };
      }
      return await this._recoverAndRefresh(), { error: null };
    } catch (e3) {
      return f(e3) ? { error: e3 } : { error: new b("Unexpected error during initialization", e3) };
    } finally {
      await this._handleVisibilityChange(), this._debug("#_initialize()", "end");
    }
  }
  async signInAnonymously(e3) {
    var t2, s2, r2;
    try {
      const i2 = await d(this.fetch, "POST", `${this.url}/signup`, { headers: this.headers, body: { data: null !== (s2 = null === (t2 = null == e3 ? void 0 : e3.options) || void 0 === t2 ? void 0 : t2.data) && void 0 !== s2 ? s2 : {}, gotrue_meta_security: { captcha_token: null === (r2 = null == e3 ? void 0 : e3.options) || void 0 === r2 ? void 0 : r2.captchaToken } }, xform: P }), { data: n2, error: a2 } = i2;
      if (a2 || !n2)
        return { data: { user: null, session: null }, error: a2 };
      const o2 = n2.session, h2 = n2.user;
      return n2.session && (await this._saveSession(n2.session), await this._notifyAllSubscribers("SIGNED_IN", o2)), { data: { user: h2, session: o2 }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async signUp(e3) {
    var t2, s2, r2;
    try {
      let i2;
      if ("email" in e3) {
        const { email: s3, password: r3, options: n3 } = e3;
        let a3 = null, o3 = null;
        "pkce" === this.flowType && ([a3, o3] = await w(this.storage, this.storageKey)), i2 = await d(this.fetch, "POST", `${this.url}/signup`, { headers: this.headers, redirectTo: null == n3 ? void 0 : n3.emailRedirectTo, body: { email: s3, password: r3, data: null !== (t2 = null == n3 ? void 0 : n3.data) && void 0 !== t2 ? t2 : {}, gotrue_meta_security: { captcha_token: null == n3 ? void 0 : n3.captchaToken }, code_challenge: a3, code_challenge_method: o3 }, xform: P });
      } else {
        if (!("phone" in e3))
          throw new k("You must provide either an email or phone number and a password");
        {
          const { phone: t3, password: n3, options: a3 } = e3;
          i2 = await d(this.fetch, "POST", `${this.url}/signup`, { headers: this.headers, body: { phone: t3, password: n3, data: null !== (s2 = null == a3 ? void 0 : a3.data) && void 0 !== s2 ? s2 : {}, channel: null !== (r2 = null == a3 ? void 0 : a3.channel) && void 0 !== r2 ? r2 : "sms", gotrue_meta_security: { captcha_token: null == a3 ? void 0 : a3.captchaToken } }, xform: P });
        }
      }
      const { data: n2, error: a2 } = i2;
      if (a2 || !n2)
        return { data: { user: null, session: null }, error: a2 };
      const o2 = n2.session, h2 = n2.user;
      return n2.session && (await this._saveSession(n2.session), await this._notifyAllSubscribers("SIGNED_IN", o2)), { data: { user: h2, session: o2 }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async signInWithPassword(e3) {
    try {
      let t2;
      if ("email" in e3) {
        const { email: s3, password: r3, options: i2 } = e3;
        t2 = await d(this.fetch, "POST", `${this.url}/token?grant_type=password`, { headers: this.headers, body: { email: s3, password: r3, gotrue_meta_security: { captcha_token: null == i2 ? void 0 : i2.captchaToken } }, xform: K });
      } else {
        if (!("phone" in e3))
          throw new k("You must provide either an email or phone number and a password");
        {
          const { phone: s3, password: r3, options: i2 } = e3;
          t2 = await d(this.fetch, "POST", `${this.url}/token?grant_type=password`, { headers: this.headers, body: { phone: s3, password: r3, gotrue_meta_security: { captcha_token: null == i2 ? void 0 : i2.captchaToken } }, xform: K });
        }
      }
      const { data: s2, error: r2 } = t2;
      return r2 ? { data: { user: null, session: null }, error: r2 } : s2 && s2.session && s2.user ? (s2.session && (await this._saveSession(s2.session), await this._notifyAllSubscribers("SIGNED_IN", s2.session)), { data: Object.assign({ user: s2.user, session: s2.session }, s2.weak_password ? { weakPassword: s2.weak_password } : null), error: r2 }) : { data: { user: null, session: null }, error: new T() };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async signInWithOAuth(e3) {
    var t2, s2, r2, i2;
    return await this._handleProviderSignIn(e3.provider, { redirectTo: null === (t2 = e3.options) || void 0 === t2 ? void 0 : t2.redirectTo, scopes: null === (s2 = e3.options) || void 0 === s2 ? void 0 : s2.scopes, queryParams: null === (r2 = e3.options) || void 0 === r2 ? void 0 : r2.queryParams, skipBrowserRedirect: null === (i2 = e3.options) || void 0 === i2 ? void 0 : i2.skipBrowserRedirect });
  }
  async exchangeCodeForSession(e3) {
    return await this.initializePromise, this._acquireLock(-1, async () => this._exchangeCodeForSession(e3));
  }
  async _exchangeCodeForSession(e3) {
    const t2 = await S(this.storage, `${this.storageKey}-code-verifier`), [s2, r2] = (null != t2 ? t2 : "").split("/");
    try {
      const { data: t3, error: i2 } = await d(this.fetch, "POST", `${this.url}/token?grant_type=pkce`, { headers: this.headers, body: { auth_code: e3, code_verifier: s2 }, xform: P });
      if (await E(this.storage, `${this.storageKey}-code-verifier`), i2)
        throw i2;
      return t3 && t3.session && t3.user ? (t3.session && (await this._saveSession(t3.session), await this._notifyAllSubscribers("SIGNED_IN", t3.session)), { data: Object.assign(Object.assign({}, t3), { redirectType: null != r2 ? r2 : null }), error: i2 }) : { data: { user: null, session: null, redirectType: null }, error: new T() };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null, redirectType: null }, error: e4 };
      throw e4;
    }
  }
  async signInWithIdToken(e3) {
    try {
      const { options: t2, provider: s2, token: r2, access_token: i2, nonce: n2 } = e3, a2 = await d(this.fetch, "POST", `${this.url}/token?grant_type=id_token`, { headers: this.headers, body: { provider: s2, id_token: r2, access_token: i2, nonce: n2, gotrue_meta_security: { captcha_token: null == t2 ? void 0 : t2.captchaToken } }, xform: P }), { data: o2, error: h2 } = a2;
      return h2 ? { data: { user: null, session: null }, error: h2 } : o2 && o2.session && o2.user ? (o2.session && (await this._saveSession(o2.session), await this._notifyAllSubscribers("SIGNED_IN", o2.session)), { data: o2, error: h2 }) : { data: { user: null, session: null }, error: new T() };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async signInWithOtp(e3) {
    var t2, s2, r2, i2, n2;
    try {
      if ("email" in e3) {
        const { email: r3, options: i3 } = e3;
        let n3 = null, a2 = null;
        "pkce" === this.flowType && ([n3, a2] = await w(this.storage, this.storageKey));
        const { error: o2 } = await d(this.fetch, "POST", `${this.url}/otp`, { headers: this.headers, body: { email: r3, data: null !== (t2 = null == i3 ? void 0 : i3.data) && void 0 !== t2 ? t2 : {}, create_user: null === (s2 = null == i3 ? void 0 : i3.shouldCreateUser) || void 0 === s2 || s2, gotrue_meta_security: { captcha_token: null == i3 ? void 0 : i3.captchaToken }, code_challenge: n3, code_challenge_method: a2 }, redirectTo: null == i3 ? void 0 : i3.emailRedirectTo });
        return { data: { user: null, session: null }, error: o2 };
      }
      if ("phone" in e3) {
        const { phone: t3, options: s3 } = e3, { data: a2, error: o2 } = await d(this.fetch, "POST", `${this.url}/otp`, { headers: this.headers, body: { phone: t3, data: null !== (r2 = null == s3 ? void 0 : s3.data) && void 0 !== r2 ? r2 : {}, create_user: null === (i2 = null == s3 ? void 0 : s3.shouldCreateUser) || void 0 === i2 || i2, gotrue_meta_security: { captcha_token: null == s3 ? void 0 : s3.captchaToken }, channel: null !== (n2 = null == s3 ? void 0 : s3.channel) && void 0 !== n2 ? n2 : "sms" } });
        return { data: { user: null, session: null, messageId: null == a2 ? void 0 : a2.message_id }, error: o2 };
      }
      throw new k("You must provide either an email or phone number.");
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async verifyOtp(e3) {
    var t2, s2;
    try {
      let r2, i2;
      "options" in e3 && (r2 = null === (t2 = e3.options) || void 0 === t2 ? void 0 : t2.redirectTo, i2 = null === (s2 = e3.options) || void 0 === s2 ? void 0 : s2.captchaToken);
      const { data: n2, error: a2 } = await d(this.fetch, "POST", `${this.url}/verify`, { headers: this.headers, body: Object.assign(Object.assign({}, e3), { gotrue_meta_security: { captcha_token: i2 } }), redirectTo: r2, xform: P });
      if (a2)
        throw a2;
      if (!n2)
        throw new Error("An error occurred on token verification.");
      const o2 = n2.session, h2 = n2.user;
      return (null == o2 ? void 0 : o2.access_token) && (await this._saveSession(o2), await this._notifyAllSubscribers("recovery" == e3.type ? "PASSWORD_RECOVERY" : "SIGNED_IN", o2)), { data: { user: h2, session: o2 }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async signInWithSSO(e3) {
    var t2, s2, r2;
    try {
      let i2 = null, n2 = null;
      return "pkce" === this.flowType && ([i2, n2] = await w(this.storage, this.storageKey)), await d(this.fetch, "POST", `${this.url}/sso`, { body: Object.assign(Object.assign(Object.assign(Object.assign(Object.assign({}, "providerId" in e3 ? { provider_id: e3.providerId } : null), "domain" in e3 ? { domain: e3.domain } : null), { redirect_to: null !== (s2 = null === (t2 = e3.options) || void 0 === t2 ? void 0 : t2.redirectTo) && void 0 !== s2 ? s2 : void 0 }), (null === (r2 = null == e3 ? void 0 : e3.options) || void 0 === r2 ? void 0 : r2.captchaToken) ? { gotrue_meta_security: { captcha_token: e3.options.captchaToken } } : null), { skip_http_redirect: true, code_challenge: i2, code_challenge_method: n2 }), headers: this.headers, xform: j });
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async reauthenticate() {
    return await this.initializePromise, await this._acquireLock(-1, async () => await this._reauthenticate());
  }
  async _reauthenticate() {
    try {
      return await this._useSession(async (e3) => {
        const { data: { session: t2 }, error: s2 } = e3;
        if (s2)
          throw s2;
        if (!t2)
          throw new $();
        const { error: r2 } = await d(this.fetch, "GET", `${this.url}/reauthenticate`, { headers: this.headers, jwt: t2.access_token });
        return { data: { user: null, session: null }, error: r2 };
      });
    } catch (e3) {
      if (f(e3))
        return { data: { user: null, session: null }, error: e3 };
      throw e3;
    }
  }
  async resend(e3) {
    try {
      const t2 = `${this.url}/resend`;
      if ("email" in e3) {
        const { email: s2, type: r2, options: i2 } = e3, { error: n2 } = await d(this.fetch, "POST", t2, { headers: this.headers, body: { email: s2, type: r2, gotrue_meta_security: { captcha_token: null == i2 ? void 0 : i2.captchaToken } }, redirectTo: null == i2 ? void 0 : i2.emailRedirectTo });
        return { data: { user: null, session: null }, error: n2 };
      }
      if ("phone" in e3) {
        const { phone: s2, type: r2, options: i2 } = e3, { data: n2, error: a2 } = await d(this.fetch, "POST", t2, { headers: this.headers, body: { phone: s2, type: r2, gotrue_meta_security: { captcha_token: null == i2 ? void 0 : i2.captchaToken } } });
        return { data: { user: null, session: null, messageId: null == n2 ? void 0 : n2.message_id }, error: a2 };
      }
      throw new k("You must provide either an email or phone number and a type");
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async getSession() {
    await this.initializePromise;
    return await this._acquireLock(-1, async () => this._useSession(async (e3) => e3));
  }
  async _acquireLock(e3, t2) {
    this._debug("#_acquireLock", "begin", e3);
    try {
      if (this.lockAcquired) {
        const e4 = this.pendingInLock.length ? this.pendingInLock[this.pendingInLock.length - 1] : Promise.resolve(), s2 = (async () => (await e4, await t2()))();
        return this.pendingInLock.push((async () => {
          try {
            await s2;
          } catch (e5) {
          }
        })()), s2;
      }
      return await this.lock(`lock:${this.storageKey}`, e3, async () => {
        this._debug("#_acquireLock", "lock acquired for storage key", this.storageKey);
        try {
          this.lockAcquired = true;
          const e4 = t2();
          for (this.pendingInLock.push((async () => {
            try {
              await e4;
            } catch (e5) {
            }
          })()), await e4; this.pendingInLock.length; ) {
            const e5 = [...this.pendingInLock];
            await Promise.all(e5), this.pendingInLock.splice(0, e5.length);
          }
          return await e4;
        } finally {
          this._debug("#_acquireLock", "lock released for storage key", this.storageKey), this.lockAcquired = false;
        }
      });
    } finally {
      this._debug("#_acquireLock", "end");
    }
  }
  async _useSession(e3) {
    this._debug("#_useSession", "begin");
    try {
      const t2 = await this.__loadSession();
      return await e3(t2);
    } finally {
      this._debug("#_useSession", "end");
    }
  }
  async __loadSession() {
    this._debug("#__loadSession()", "begin"), this.lockAcquired || this._debug("#__loadSession()", "used outside of an acquired lock!", new Error().stack);
    try {
      let e3 = null;
      const t2 = await S(this.storage, this.storageKey);
      if (this._debug("#getSession()", "session from storage", t2), null !== t2 && (this._isValidSession(t2) ? e3 = t2 : (this._debug("#getSession()", "session from storage is not valid"), await this._removeSession())), !e3)
        return { data: { session: null }, error: null };
      const s2 = !!e3.expires_at && e3.expires_at <= Date.now() / 1e3;
      if (this._debug("#__loadSession()", `session has${s2 ? "" : " not"} expired`, "expires_at", e3.expires_at), !s2) {
        if (this.storage.isServer) {
          let t3 = this.suppressGetSessionWarning;
          e3 = new Proxy(e3, { get: (e4, s3, r3) => (t3 || "user" !== s3 || (t3 = true, this.suppressGetSessionWarning = true), Reflect.get(e4, s3, r3)) });
        }
        return { data: { session: e3 }, error: null };
      }
      const { session: r2, error: i2 } = await this._callRefreshToken(e3.refresh_token);
      return i2 ? { data: { session: null }, error: i2 } : { data: { session: r2 }, error: null };
    } finally {
      this._debug("#__loadSession()", "end");
    }
  }
  async getUser(e3) {
    if (e3)
      return await this._getUser(e3);
    await this.initializePromise;
    return await this._acquireLock(-1, async () => await this._getUser());
  }
  async _getUser(e3) {
    try {
      return e3 ? await d(this.fetch, "GET", `${this.url}/user`, { headers: this.headers, jwt: e3, xform: g }) : await this._useSession(async (e4) => {
        var t2, s2, r2;
        const { data: i2, error: n2 } = e4;
        if (n2)
          throw n2;
        return (null === (t2 = i2.session) || void 0 === t2 ? void 0 : t2.access_token) || this.hasCustomAuthorizationHeader ? await d(this.fetch, "GET", `${this.url}/user`, { headers: this.headers, jwt: null !== (r2 = null === (s2 = i2.session) || void 0 === s2 ? void 0 : s2.access_token) && void 0 !== r2 ? r2 : void 0, xform: g }) : { data: { user: null }, error: new $() };
      });
    } catch (e4) {
      if (f(e4))
        return O(e4) && (await this._removeSession(), await E(this.storage, `${this.storageKey}-code-verifier`), await this._notifyAllSubscribers("SIGNED_OUT", null)), { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  async updateUser(e3, t2 = {}) {
    return await this.initializePromise, await this._acquireLock(-1, async () => await this._updateUser(e3, t2));
  }
  async _updateUser(e3, t2 = {}) {
    try {
      return await this._useSession(async (s2) => {
        const { data: r2, error: i2 } = s2;
        if (i2)
          throw i2;
        if (!r2.session)
          throw new $();
        const n2 = r2.session;
        let a2 = null, o2 = null;
        "pkce" === this.flowType && null != e3.email && ([a2, o2] = await w(this.storage, this.storageKey));
        const { data: h2, error: l2 } = await d(this.fetch, "PUT", `${this.url}/user`, { headers: this.headers, redirectTo: null == t2 ? void 0 : t2.emailRedirectTo, body: Object.assign(Object.assign({}, e3), { code_challenge: a2, code_challenge_method: o2 }), jwt: n2.access_token, xform: g });
        if (l2)
          throw l2;
        return n2.user = h2.user, await this._saveSession(n2), await this._notifyAllSubscribers("USER_UPDATED", n2), { data: { user: n2.user }, error: null };
      });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null }, error: e4 };
      throw e4;
    }
  }
  _decodeJWT(e3) {
    return A(e3);
  }
  async setSession(e3) {
    return await this.initializePromise, await this._acquireLock(-1, async () => await this._setSession(e3));
  }
  async _setSession(e3) {
    try {
      if (!e3.access_token || !e3.refresh_token)
        throw new $();
      const t2 = Date.now() / 1e3;
      let s2 = t2, r2 = true, i2 = null;
      const n2 = A(e3.access_token);
      if (n2.exp && (s2 = n2.exp, r2 = s2 <= t2), r2) {
        const { session: t3, error: s3 } = await this._callRefreshToken(e3.refresh_token);
        if (s3)
          return { data: { user: null, session: null }, error: s3 };
        if (!t3)
          return { data: { user: null, session: null }, error: null };
        i2 = t3;
      } else {
        const { data: r3, error: n3 } = await this._getUser(e3.access_token);
        if (n3)
          throw n3;
        i2 = { access_token: e3.access_token, refresh_token: e3.refresh_token, user: r3.user, token_type: "bearer", expires_in: s2 - t2, expires_at: s2 }, await this._saveSession(i2), await this._notifyAllSubscribers("SIGNED_IN", i2);
      }
      return { data: { user: i2.user, session: i2 }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { session: null, user: null }, error: e4 };
      throw e4;
    }
  }
  async refreshSession(e3) {
    return await this.initializePromise, await this._acquireLock(-1, async () => await this._refreshSession(e3));
  }
  async _refreshSession(e3) {
    try {
      return await this._useSession(async (t2) => {
        var s2;
        if (!e3) {
          const { data: r3, error: i3 } = t2;
          if (i3)
            throw i3;
          e3 = null !== (s2 = r3.session) && void 0 !== s2 ? s2 : void 0;
        }
        if (!(null == e3 ? void 0 : e3.refresh_token))
          throw new $();
        const { session: r2, error: i2 } = await this._callRefreshToken(e3.refresh_token);
        return i2 ? { data: { user: null, session: null }, error: i2 } : r2 ? { data: { user: r2.user, session: r2 }, error: null } : { data: { user: null, session: null }, error: null };
      });
    } catch (e4) {
      if (f(e4))
        return { data: { user: null, session: null }, error: e4 };
      throw e4;
    }
  }
  async _getSessionFromURL(e3) {
    try {
      if (!m())
        throw new C("No browser detected.");
      if ("implicit" === this.flowType && !this._isImplicitGrantFlow())
        throw new C("Not a valid implicit grant flow url.");
      if ("pkce" == this.flowType && !e3)
        throw new R("Not a valid PKCE flow url.");
      const t2 = I(window.location.href);
      if (e3) {
        if (!t2.code)
          throw new R("No code detected.");
        const { data: e4, error: s3 } = await this._exchangeCodeForSession(t2.code);
        if (s3)
          throw s3;
        const r3 = new URL(window.location.href);
        return r3.searchParams.delete("code"), window.history.replaceState(window.history.state, "", r3.toString()), { data: { session: e4.session, redirectType: null }, error: null };
      }
      if (t2.error || t2.error_description || t2.error_code)
        throw new C(t2.error_description || "Error in URL with unspecified error_description", { error: t2.error || "unspecified_error", code: t2.error_code || "unspecified_code" });
      const { provider_token: s2, provider_refresh_token: r2, access_token: i2, refresh_token: n2, expires_in: a2, expires_at: o2, token_type: h2 } = t2;
      if (!(i2 && a2 && n2 && h2))
        throw new C("No session defined in URL");
      const l2 = Math.round(Date.now() / 1e3), c2 = parseInt(a2);
      let u2 = l2 + c2;
      o2 && (u2 = parseInt(o2));
      const { data: d2, error: f2 } = await this._getUser(i2);
      if (f2)
        throw f2;
      const p2 = { provider_token: s2, provider_refresh_token: r2, access_token: i2, expires_in: c2, expires_at: u2, refresh_token: n2, token_type: h2, user: d2.user };
      return window.location.hash = "", this._debug("#_getSessionFromURL()", "clearing window.location.hash"), { data: { session: p2, redirectType: t2.type }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: { session: null, redirectType: null }, error: e4 };
      throw e4;
    }
  }
  _isImplicitGrantFlow() {
    const e3 = I(window.location.href);
    return !(!m() || !e3.access_token && !e3.error_description);
  }
  async _isPKCEFlow() {
    const e3 = I(window.location.href), t2 = await S(this.storage, `${this.storageKey}-code-verifier`);
    return !(!e3.code || !t2);
  }
  async signOut(e3 = { scope: "global" }) {
    return await this.initializePromise, await this._acquireLock(-1, async () => await this._signOut(e3));
  }
  async _signOut({ scope: e3 } = { scope: "global" }) {
    return await this._useSession(async (t2) => {
      var s2;
      const { data: r2, error: i2 } = t2;
      if (i2)
        return { error: i2 };
      const n2 = null === (s2 = r2.session) || void 0 === s2 ? void 0 : s2.access_token;
      if (n2) {
        const { error: t3 } = await this.admin.signOut(n2, e3);
        if (t3 && (!L(t3) || 404 !== t3.status && 401 !== t3.status && 403 !== t3.status))
          return { error: t3 };
      }
      return "others" !== e3 && (await this._removeSession(), await E(this.storage, `${this.storageKey}-code-verifier`), await this._notifyAllSubscribers("SIGNED_OUT", null)), { error: null };
    });
  }
  onAuthStateChange(e3) {
    const t2 = x(), s2 = { id: t2, callback: e3, unsubscribe: () => {
      this._debug("#unsubscribe()", "state change callback with id removed", t2), this.stateChangeEmitters.delete(t2);
    } };
    return this._debug("#onAuthStateChange()", "registered callback with id", t2), this.stateChangeEmitters.set(t2, s2), (async () => {
      await this.initializePromise, await this._acquireLock(-1, async () => {
        this._emitInitialSession(t2);
      });
    })(), { data: { subscription: s2 } };
  }
  async _emitInitialSession(e3) {
    return await this._useSession(async (t2) => {
      var s2, r2;
      try {
        const { data: { session: r3 }, error: i2 } = t2;
        if (i2)
          throw i2;
        await (null === (s2 = this.stateChangeEmitters.get(e3)) || void 0 === s2 ? void 0 : s2.callback("INITIAL_SESSION", r3)), this._debug("INITIAL_SESSION", "callback id", e3, "session", r3);
      } catch (t3) {
        await (null === (r2 = this.stateChangeEmitters.get(e3)) || void 0 === r2 ? void 0 : r2.callback("INITIAL_SESSION", null)), this._debug("INITIAL_SESSION", "callback id", e3, "error", t3);
      }
    });
  }
  async resetPasswordForEmail(e3, t2 = {}) {
    let s2 = null, r2 = null;
    "pkce" === this.flowType && ([s2, r2] = await w(this.storage, this.storageKey, true));
    try {
      return await d(this.fetch, "POST", `${this.url}/recover`, { body: { email: e3, code_challenge: s2, code_challenge_method: r2, gotrue_meta_security: { captcha_token: t2.captchaToken } }, headers: this.headers, redirectTo: t2.redirectTo });
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async getUserIdentities() {
    var e3;
    try {
      const { data: t2, error: s2 } = await this.getUser();
      if (s2)
        throw s2;
      return { data: { identities: null !== (e3 = t2.user.identities) && void 0 !== e3 ? e3 : [] }, error: null };
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async linkIdentity(e3) {
    var t2;
    try {
      const { data: s2, error: r2 } = await this._useSession(async (t3) => {
        var s3, r3, i2, n2, a2;
        const { data: o2, error: h2 } = t3;
        if (h2)
          throw h2;
        const l2 = await this._getUrlForProvider(`${this.url}/user/identities/authorize`, e3.provider, { redirectTo: null === (s3 = e3.options) || void 0 === s3 ? void 0 : s3.redirectTo, scopes: null === (r3 = e3.options) || void 0 === r3 ? void 0 : r3.scopes, queryParams: null === (i2 = e3.options) || void 0 === i2 ? void 0 : i2.queryParams, skipBrowserRedirect: true });
        return await d(this.fetch, "GET", l2, { headers: this.headers, jwt: null !== (a2 = null === (n2 = o2.session) || void 0 === n2 ? void 0 : n2.access_token) && void 0 !== a2 ? a2 : void 0 });
      });
      if (r2)
        throw r2;
      return m() && !(null === (t2 = e3.options) || void 0 === t2 ? void 0 : t2.skipBrowserRedirect) && window.location.assign(null == s2 ? void 0 : s2.url), { data: { provider: e3.provider, url: null == s2 ? void 0 : s2.url }, error: null };
    } catch (t3) {
      if (f(t3))
        return { data: { provider: e3.provider, url: null }, error: t3 };
      throw t3;
    }
  }
  async unlinkIdentity(e3) {
    try {
      return await this._useSession(async (t2) => {
        var s2, r2;
        const { data: i2, error: n2 } = t2;
        if (n2)
          throw n2;
        return await d(this.fetch, "DELETE", `${this.url}/user/identities/${e3.identity_id}`, { headers: this.headers, jwt: null !== (r2 = null === (s2 = i2.session) || void 0 === s2 ? void 0 : s2.access_token) && void 0 !== r2 ? r2 : void 0 });
      });
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async _refreshAccessToken(e3) {
    const t2 = `#_refreshAccessToken(${e3.substring(0, 5)}...)`;
    this._debug(t2, "begin");
    try {
      const s2 = Date.now();
      return await U(async (s3) => (s3 > 0 && await G(200 * Math.pow(2, s3 - 1)), this._debug(t2, "refreshing attempt", s3), await d(this.fetch, "POST", `${this.url}/token?grant_type=refresh_token`, { body: { refresh_token: e3 }, headers: this.headers, xform: P })), (e4, t3) => {
        const r2 = 200 * Math.pow(2, e4);
        return t3 && N(t3) && Date.now() + r2 - s2 < Gt;
      });
    } catch (e4) {
      if (this._debug(t2, "error", e4), f(e4))
        return { data: { session: null, user: null }, error: e4 };
      throw e4;
    } finally {
      this._debug(t2, "end");
    }
  }
  _isValidSession(e3) {
    return "object" == typeof e3 && null !== e3 && "access_token" in e3 && "refresh_token" in e3 && "expires_at" in e3;
  }
  async _handleProviderSignIn(e3, t2) {
    const s2 = await this._getUrlForProvider(`${this.url}/authorize`, e3, { redirectTo: t2.redirectTo, scopes: t2.scopes, queryParams: t2.queryParams });
    return this._debug("#_handleProviderSignIn()", "provider", e3, "options", t2, "url", s2), m() && !t2.skipBrowserRedirect && window.location.assign(s2), { data: { provider: e3, url: s2 }, error: null };
  }
  async _recoverAndRefresh() {
    var e3;
    const t2 = "#_recoverAndRefresh()";
    this._debug(t2, "begin");
    try {
      const s2 = await S(this.storage, this.storageKey);
      if (this._debug(t2, "session from storage", s2), !this._isValidSession(s2))
        return this._debug(t2, "session is not valid"), void (null !== s2 && await this._removeSession());
      const r2 = Math.round(Date.now() / 1e3), i2 = (null !== (e3 = s2.expires_at) && void 0 !== e3 ? e3 : 1 / 0) < r2 + D;
      if (this._debug(t2, `session has${i2 ? "" : " not"} expired with margin of ${D}s`), i2) {
        if (this.autoRefreshToken && s2.refresh_token) {
          const { error: e4 } = await this._callRefreshToken(s2.refresh_token);
          e4 && (N(e4) || (this._debug(t2, "refresh failed with a non-retryable error, removing the session", e4), await this._removeSession()));
        }
      } else
        await this._notifyAllSubscribers("SIGNED_IN", s2);
    } catch (e4) {
      return void this._debug(t2, "error", e4);
    } finally {
      this._debug(t2, "end");
    }
  }
  async _callRefreshToken(e3) {
    var t2, s2;
    if (!e3)
      throw new $();
    if (this.refreshingDeferred)
      return this.refreshingDeferred.promise;
    const r2 = `#_callRefreshToken(${e3.substring(0, 5)}...)`;
    this._debug(r2, "begin");
    try {
      this.refreshingDeferred = new F();
      const { data: t3, error: s3 } = await this._refreshAccessToken(e3);
      if (s3)
        throw s3;
      if (!t3.session)
        throw new $();
      await this._saveSession(t3.session), await this._notifyAllSubscribers("TOKEN_REFRESHED", t3.session);
      const r3 = { session: t3.session, error: null };
      return this.refreshingDeferred.resolve(r3), r3;
    } catch (e4) {
      if (this._debug(r2, "error", e4), f(e4)) {
        const s3 = { session: null, error: e4 };
        return N(e4) || (await this._removeSession(), await this._notifyAllSubscribers("SIGNED_OUT", null)), null === (t2 = this.refreshingDeferred) || void 0 === t2 || t2.resolve(s3), s3;
      }
      throw null === (s2 = this.refreshingDeferred) || void 0 === s2 || s2.reject(e4), e4;
    } finally {
      this.refreshingDeferred = null, this._debug(r2, "end");
    }
  }
  async _notifyAllSubscribers(e3, t2, s2 = true) {
    const r2 = `#_notifyAllSubscribers(${e3})`;
    this._debug(r2, "begin", t2, `broadcast = ${s2}`);
    try {
      this.broadcastChannel && s2 && this.broadcastChannel.postMessage({ event: e3, session: t2 });
      const r3 = [], i2 = Array.from(this.stateChangeEmitters.values()).map(async (s3) => {
        try {
          await s3.callback(e3, t2);
        } catch (e4) {
          r3.push(e4);
        }
      });
      if (await Promise.all(i2), r3.length > 0) {
        for (let e4 = 0; e4 < r3.length; e4 += 1)
          ;
        throw r3[0];
      }
    } finally {
      this._debug(r2, "end");
    }
  }
  async _saveSession(e3) {
    this._debug("#_saveSession()", e3), this.suppressGetSessionWarning = true, await B(this.storage, this.storageKey, e3);
  }
  async _removeSession() {
    this._debug("#_removeSession()"), await E(this.storage, this.storageKey);
  }
  _removeVisibilityChangedCallback() {
    this._debug("#_removeVisibilityChangedCallback()");
    const e3 = this.visibilityChangedCallback;
    this.visibilityChangedCallback = null;
    try {
      e3 && m() && (null === window || void 0 === window ? void 0 : window.removeEventListener) && window.removeEventListener("visibilitychange", e3);
    } catch (e4) {
    }
  }
  async _startAutoRefresh() {
    await this._stopAutoRefresh(), this._debug("#_startAutoRefresh()");
    const e3 = setInterval(() => this._autoRefreshTokenTick(), Gt);
    this.autoRefreshTicker = e3, e3 && "object" == typeof e3 && "function" == typeof e3.unref ? e3.unref() : "undefined" != typeof Deno && "function" == typeof Deno.unrefTimer && Deno.unrefTimer(e3), setTimeout(async () => {
      await this.initializePromise, await this._autoRefreshTokenTick();
    }, 0);
  }
  async _stopAutoRefresh() {
    this._debug("#_stopAutoRefresh()");
    const e3 = this.autoRefreshTicker;
    this.autoRefreshTicker = null, e3 && clearInterval(e3);
  }
  async startAutoRefresh() {
    this._removeVisibilityChangedCallback(), await this._startAutoRefresh();
  }
  async stopAutoRefresh() {
    this._removeVisibilityChangedCallback(), await this._stopAutoRefresh();
  }
  async _autoRefreshTokenTick() {
    this._debug("#_autoRefreshTokenTick()", "begin");
    try {
      await this._acquireLock(0, async () => {
        try {
          const e3 = Date.now();
          try {
            return await this._useSession(async (t2) => {
              const { data: { session: s2 } } = t2;
              if (!s2 || !s2.refresh_token || !s2.expires_at)
                return void this._debug("#_autoRefreshTokenTick()", "no session");
              const r2 = Math.floor((1e3 * s2.expires_at - e3) / Gt);
              this._debug("#_autoRefreshTokenTick()", `access token expires in ${r2} ticks, a tick lasts 30000ms, refresh threshold is 3 ticks`), r2 <= 3 && await this._callRefreshToken(s2.refresh_token);
            });
          } catch (e4) {
          }
        } finally {
          this._debug("#_autoRefreshTokenTick()", "end");
        }
      });
    } catch (e3) {
      if (!(e3.isAcquireTimeout || e3 instanceof Mt))
        throw e3;
      this._debug("auto refresh token tick lock not available");
    }
  }
  async _handleVisibilityChange() {
    if (this._debug("#_handleVisibilityChange()"), !m() || !(null === window || void 0 === window ? void 0 : window.addEventListener))
      return this.autoRefreshToken && this.startAutoRefresh(), false;
    try {
      this.visibilityChangedCallback = async () => await this._onVisibilityChanged(false), null === window || void 0 === window || window.addEventListener("visibilitychange", this.visibilityChangedCallback), await this._onVisibilityChanged(true);
    } catch (e3) {
    }
  }
  async _onVisibilityChanged(e3) {
    const t2 = `#_onVisibilityChanged(${e3})`;
    this._debug(t2, "visibilityState", document.visibilityState), "visible" === document.visibilityState ? (this.autoRefreshToken && this._startAutoRefresh(), e3 || (await this.initializePromise, await this._acquireLock(-1, async () => {
      "visible" === document.visibilityState ? await this._recoverAndRefresh() : this._debug(t2, "acquired the lock to recover the session, but the browser visibilityState is no longer visible, aborting");
    }))) : "hidden" === document.visibilityState && this.autoRefreshToken && this._stopAutoRefresh();
  }
  async _getUrlForProvider(e3, t2, s2) {
    const r2 = [`provider=${encodeURIComponent(t2)}`];
    if ((null == s2 ? void 0 : s2.redirectTo) && r2.push(`redirect_to=${encodeURIComponent(s2.redirectTo)}`), (null == s2 ? void 0 : s2.scopes) && r2.push(`scopes=${encodeURIComponent(s2.scopes)}`), "pkce" === this.flowType) {
      const [e4, t3] = await w(this.storage, this.storageKey), s3 = new URLSearchParams({ code_challenge: `${encodeURIComponent(e4)}`, code_challenge_method: `${encodeURIComponent(t3)}` });
      r2.push(s3.toString());
    }
    if (null == s2 ? void 0 : s2.queryParams) {
      const e4 = new URLSearchParams(s2.queryParams);
      r2.push(e4.toString());
    }
    return (null == s2 ? void 0 : s2.skipBrowserRedirect) && r2.push(`skip_http_redirect=${s2.skipBrowserRedirect}`), `${e3}?${r2.join("&")}`;
  }
  async _unenroll(e3) {
    try {
      return await this._useSession(async (t2) => {
        var s2;
        const { data: r2, error: i2 } = t2;
        return i2 ? { data: null, error: i2 } : await d(this.fetch, "DELETE", `${this.url}/factors/${e3.factorId}`, { headers: this.headers, jwt: null === (s2 = null == r2 ? void 0 : r2.session) || void 0 === s2 ? void 0 : s2.access_token });
      });
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async _enroll(e3) {
    try {
      return await this._useSession(async (t2) => {
        var s2, r2;
        const { data: i2, error: n2 } = t2;
        if (n2)
          return { data: null, error: n2 };
        const a2 = Object.assign({ friendly_name: e3.friendlyName, factor_type: e3.factorType }, "phone" === e3.factorType ? { phone: e3.phone } : { issuer: e3.issuer }), { data: o2, error: h2 } = await d(this.fetch, "POST", `${this.url}/factors`, { body: a2, headers: this.headers, jwt: null === (s2 = null == i2 ? void 0 : i2.session) || void 0 === s2 ? void 0 : s2.access_token });
        return h2 ? { data: null, error: h2 } : ("phone" === e3.factorType && delete o2.totp, "totp" === e3.factorType && (null === (r2 = null == o2 ? void 0 : o2.totp) || void 0 === r2 ? void 0 : r2.qr_code) && (o2.totp.qr_code = `data:image/svg+xml;utf-8,${o2.totp.qr_code}`), { data: o2, error: null });
      });
    } catch (e4) {
      if (f(e4))
        return { data: null, error: e4 };
      throw e4;
    }
  }
  async _verify(e3) {
    return this._acquireLock(-1, async () => {
      try {
        return await this._useSession(async (t2) => {
          var s2;
          const { data: r2, error: i2 } = t2;
          if (i2)
            return { data: null, error: i2 };
          const { data: n2, error: a2 } = await d(this.fetch, "POST", `${this.url}/factors/${e3.factorId}/verify`, { body: { code: e3.code, challenge_id: e3.challengeId }, headers: this.headers, jwt: null === (s2 = null == r2 ? void 0 : r2.session) || void 0 === s2 ? void 0 : s2.access_token });
          return a2 ? { data: null, error: a2 } : (await this._saveSession(Object.assign({ expires_at: Math.round(Date.now() / 1e3) + n2.expires_in }, n2)), await this._notifyAllSubscribers("MFA_CHALLENGE_VERIFIED", n2), { data: n2, error: a2 });
        });
      } catch (e4) {
        if (f(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  async _challenge(e3) {
    return this._acquireLock(-1, async () => {
      try {
        return await this._useSession(async (t2) => {
          var s2;
          const { data: r2, error: i2 } = t2;
          return i2 ? { data: null, error: i2 } : await d(this.fetch, "POST", `${this.url}/factors/${e3.factorId}/challenge`, { body: { channel: e3.channel }, headers: this.headers, jwt: null === (s2 = null == r2 ? void 0 : r2.session) || void 0 === s2 ? void 0 : s2.access_token });
        });
      } catch (e4) {
        if (f(e4))
          return { data: null, error: e4 };
        throw e4;
      }
    });
  }
  async _challengeAndVerify(e3) {
    const { data: t2, error: s2 } = await this._challenge({ factorId: e3.factorId });
    return s2 ? { data: null, error: s2 } : await this._verify({ factorId: e3.factorId, challengeId: t2.id, code: e3.code });
  }
  async _listFactors() {
    const { data: { user: e3 }, error: t2 } = await this.getUser();
    if (t2)
      return { data: null, error: t2 };
    const s2 = (null == e3 ? void 0 : e3.factors) || [], r2 = s2.filter((e4) => "totp" === e4.factor_type && "verified" === e4.status), i2 = s2.filter((e4) => "phone" === e4.factor_type && "verified" === e4.status);
    return { data: { all: s2, totp: r2, phone: i2 }, error: null };
  }
  async _getAuthenticatorAssuranceLevel() {
    return this._acquireLock(-1, async () => await this._useSession(async (e3) => {
      var t2, s2;
      const { data: { session: r2 }, error: i2 } = e3;
      if (i2)
        return { data: null, error: i2 };
      if (!r2)
        return { data: { currentLevel: null, nextLevel: null, currentAuthenticationMethods: [] }, error: null };
      const n2 = this._decodeJWT(r2.access_token);
      let a2 = null;
      n2.aal && (a2 = n2.aal);
      let o2 = a2;
      (null !== (s2 = null === (t2 = r2.user.factors) || void 0 === t2 ? void 0 : t2.filter((e4) => "verified" === e4.status)) && void 0 !== s2 ? s2 : []).length > 0 && (o2 = "aal2");
      return { data: { currentLevel: a2, nextLevel: o2, currentAuthenticationMethods: n2.amr || [] }, error: null };
    }));
  }
}
Jt.nextInstanceID = 0;
const Vt = Dt, Wt = Jt;
class Yt extends Wt {
  constructor(e3) {
    super(e3);
  }
}
var Qt = globalThis && globalThis.__awaiter || function(e3, t2, s2, r2) {
  return new (s2 || (s2 = Promise))(function(i2, n2) {
    function a2(e4) {
      try {
        h2(r2.next(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function o2(e4) {
      try {
        h2(r2.throw(e4));
      } catch (e5) {
        n2(e5);
      }
    }
    function h2(e4) {
      var t3;
      e4.done ? i2(e4.value) : (t3 = e4.value, t3 instanceof s2 ? t3 : new s2(function(e5) {
        e5(t3);
      })).then(a2, o2);
    }
    h2((r2 = r2.apply(e3, t2 || [])).next());
  });
};
class Xt {
  constructor(e3, t2, s2) {
    var r2, i2, n2;
    if (this.supabaseUrl = e3, this.supabaseKey = t2, !e3)
      throw new Error("supabaseUrl is required.");
    if (!t2)
      throw new Error("supabaseKey is required.");
    const a2 = e3.replace(/\/$/, "");
    this.realtimeUrl = `${a2}/realtime/v1`.replace(/^http/i, "ws"), this.authUrl = `${a2}/auth/v1`, this.storageUrl = `${a2}/storage/v1`, this.functionsUrl = `${a2}/functions/v1`;
    const o2 = `sb-${new URL(this.authUrl).hostname.split(".")[0]}-auth-token`, h2 = function(e4, t3) {
      const { db: s3, auth: r3, realtime: i3, global: n3 } = e4, { db: a3, auth: o3, realtime: h3, global: l2 } = t3, c2 = { db: Object.assign(Object.assign({}, a3), s3), auth: Object.assign(Object.assign({}, o3), r3), realtime: Object.assign(Object.assign({}, h3), i3), global: Object.assign(Object.assign({}, l2), n3), accessToken: () => xt(this, void 0, void 0, function* () {
        return "";
      }) };
      return e4.accessToken ? c2.accessToken = e4.accessToken : delete c2.accessToken, c2;
    }(null != s2 ? s2 : {}, { db: Rt, realtime: Lt, auth: Object.assign(Object.assign({}, It), { storageKey: o2 }), global: Ct });
    this.storageKey = null !== (r2 = h2.auth.storageKey) && void 0 !== r2 ? r2 : "", this.headers = null !== (i2 = h2.global.headers) && void 0 !== i2 ? i2 : {}, h2.accessToken ? (this.accessToken = h2.accessToken, this.auth = new Proxy({}, { get: (e4, t3) => {
      throw new Error(`@supabase/supabase-js: Supabase Client is configured with the accessToken option, accessing supabase.auth.${String(t3)} is not possible`);
    } })) : this.auth = this._initSupabaseAuthClient(null !== (n2 = h2.auth) && void 0 !== n2 ? n2 : {}, this.headers, h2.global.fetch), this.fetch = H(t2, this._getAccessToken.bind(this), h2.global.fetch), this.realtime = this._initRealtimeClient(Object.assign({ headers: this.headers }, h2.realtime)), this.rest = new Be(`${a2}/rest/v1`, { headers: this.headers, schema: h2.db.schema, fetch: this.fetch }), h2.accessToken || this._listenForAuthEvents();
  }
  get functions() {
    return new ae(this.functionsUrl, { headers: this.headers, customFetch: this.fetch });
  }
  get storage() {
    return new Ot(this.storageUrl, this.headers, this.fetch);
  }
  from(e3) {
    return this.rest.from(e3);
  }
  schema(e3) {
    return this.rest.schema(e3);
  }
  rpc(e3, t2 = {}, s2 = {}) {
    return this.rest.rpc(e3, t2, s2);
  }
  channel(e3, t2 = { config: {} }) {
    return this.realtime.channel(e3, t2);
  }
  getChannels() {
    return this.realtime.getChannels();
  }
  removeChannel(e3) {
    return this.realtime.removeChannel(e3);
  }
  removeAllChannels() {
    return this.realtime.removeAllChannels();
  }
  _getAccessToken() {
    var e3, t2;
    return Qt(this, void 0, void 0, function* () {
      if (this.accessToken)
        return yield this.accessToken();
      const { data: s2 } = yield this.auth.getSession();
      return null !== (t2 = null === (e3 = s2.session) || void 0 === e3 ? void 0 : e3.access_token) && void 0 !== t2 ? t2 : null;
    });
  }
  _initSupabaseAuthClient({ autoRefreshToken: e3, persistSession: t2, detectSessionInUrl: s2, storage: r2, storageKey: i2, flowType: n2, lock: a2, debug: o2 }, h2, l2) {
    var c2;
    const u2 = { Authorization: `Bearer ${this.supabaseKey}`, apikey: `${this.supabaseKey}` };
    return new Yt({ url: this.authUrl, headers: Object.assign(Object.assign({}, u2), h2), storageKey: i2, autoRefreshToken: e3, persistSession: t2, detectSessionInUrl: s2, storage: r2, flowType: n2, lock: a2, debug: o2, fetch: l2, hasCustomAuthorizationHeader: null !== (c2 = "Authorization" in this.headers) && void 0 !== c2 && c2 });
  }
  _initRealtimeClient(e3) {
    return new bt(this.realtimeUrl, Object.assign(Object.assign({}, e3), { params: Object.assign({ apikey: this.supabaseKey }, null == e3 ? void 0 : e3.params) }));
  }
  _listenForAuthEvents() {
    return this.auth.onAuthStateChange((e3, t2) => {
      this._handleTokenChanged(e3, "CLIENT", null == t2 ? void 0 : t2.access_token);
    });
  }
  _handleTokenChanged(e3, t2, s2) {
    "TOKEN_REFRESHED" !== e3 && "SIGNED_IN" !== e3 || this.changedAccessToken === s2 ? "SIGNED_OUT" === e3 && (this.realtime.setAuth(this.supabaseKey), "STORAGE" == t2 && this.auth.signOut(), this.changedAccessToken = void 0) : (this.realtime.setAuth(null != s2 ? s2 : null), this.changedAccessToken = s2);
  }
}
const Zt = Object.freeze(Object.defineProperty({ __proto__: null, AuthAdminApi: Vt, AuthApiError: J, AuthClient: Wt, AuthError: V, AuthImplicitGrantRedirectError: C, AuthInvalidCredentialsError: k, AuthInvalidTokenResponseError: T, AuthPKCEGrantCodeExchangeError: R, AuthRetryableFetchError: W, AuthSessionMissingError: $, AuthUnknownError: b, AuthWeakPasswordError: Y, CustomAuthError: Q, get FunctionRegion() {
  return ie;
}, FunctionsError: ee, FunctionsFetchError: te, FunctionsHttpError: re, FunctionsRelayError: se, GoTrueAdminApi: Dt, GoTrueClient: Jt, NavigatorLockAcquireTimeoutError: qt, REALTIME_CHANNEL_STATES: _t, get REALTIME_LISTEN_TYPES() {
  return ft;
}, get REALTIME_POSTGRES_CHANGES_LISTEN_EVENT() {
  return dt;
}, get REALTIME_PRESENCE_LISTEN_EVENTS() {
  return ut;
}, get REALTIME_SUBSCRIBE_STATES() {
  return pt;
}, RealtimeChannel: yt, RealtimeClient: bt, RealtimePresence: gt, SupabaseClient: Xt, createClient: (e3, t2, s2) => new Xt(e3, t2, s2), isAuthApiError: L, isAuthError: f, isAuthRetryableFetchError: N, isAuthSessionMissingError: O, isAuthWeakPasswordError: X, lockInternals: Bt, navigatorLock: zt }, Symbol.toStringTag, { value: "Module" }));
export {
  Zt as s
};
